define(["exports","../utils/events.js","../utils/logger.js","../utils/logging-control.js","./transmuxing-controller.js","./transmuxing-events.js","./transmuxing-worker.js","./media-info.js"],function(_exports,_events,_logger,_loggingControl,_transmuxingController,_transmuxingEvents,_transmuxingWorker,_mediaInfo){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.default=void 0;_exports.default=class{constructor(mediaDataSource,config){if(this.TAG="Transmuxer",this._emitter=new _events.default,config.enableWorker&&"undefined"!=typeof Worker)try{var work=require("webworkify");this._worker=work(_transmuxingWorker.default),this._workerDestroying=!1,this._worker.addEventListener("message",this._onWorkerMessage.bind(this)),this._worker.postMessage({cmd:"init",param:[mediaDataSource,config]}),this.e={onLoggingConfigChanged:this._onLoggingConfigChanged.bind(this)},_loggingControl.default.registerListener(this.e.onLoggingConfigChanged),this._worker.postMessage({cmd:"logging_config",param:_loggingControl.default.getConfig()})}catch(error){_logger.default.e(this.TAG,"Error while initialize transmuxing worker, fallback to inline transmuxing"),this._worker=null,this._controller=new _transmuxingController.default(mediaDataSource,config)}else this._controller=new _transmuxingController.default(mediaDataSource,config);this._controller&&((work=this._controller).on(_transmuxingEvents.default.IO_ERROR,this._onIOError.bind(this)),work.on(_transmuxingEvents.default.DEMUX_ERROR,this._onDemuxError.bind(this)),work.on(_transmuxingEvents.default.INIT_SEGMENT,this._onInitSegment.bind(this)),work.on(_transmuxingEvents.default.MEDIA_SEGMENT,this._onMediaSegment.bind(this)),work.on(_transmuxingEvents.default.LOADING_COMPLETE,this._onLoadingComplete.bind(this)),work.on(_transmuxingEvents.default.RECOVERED_EARLY_EOF,this._onRecoveredEarlyEof.bind(this)),work.on(_transmuxingEvents.default.MEDIA_INFO,this._onMediaInfo.bind(this)),work.on(_transmuxingEvents.default.METADATA_ARRIVED,this._onMetaDataArrived.bind(this)),work.on(_transmuxingEvents.default.SCRIPTDATA_ARRIVED,this._onScriptDataArrived.bind(this)),work.on(_transmuxingEvents.default.STATISTICS_INFO,this._onStatisticsInfo.bind(this)),work.on(_transmuxingEvents.default.RECOMMEND_SEEKPOINT,this._onRecommendSeekpoint.bind(this)))}destroy(){this._worker?this._workerDestroying||(this._workerDestroying=!0,this._worker.postMessage({cmd:"destroy"}),_loggingControl.default.removeListener(this.e.onLoggingConfigChanged),this.e=null):(this._controller.destroy(),this._controller=null),this._emitter.removeAllListeners(),this._emitter=null}on(event,listener){this._emitter.addListener(event,listener)}off(event,listener){this._emitter.removeListener(event,listener)}hasWorker(){return null!=this._worker}open(){this._worker?this._worker.postMessage({cmd:"start"}):this._controller.start()}close(){this._worker?this._worker.postMessage({cmd:"stop"}):this._controller.stop()}seek(milliseconds){this._worker?this._worker.postMessage({cmd:"seek",param:milliseconds}):this._controller.seek(milliseconds)}pause(){this._worker?this._worker.postMessage({cmd:"pause"}):this._controller.pause()}resume(){this._worker?this._worker.postMessage({cmd:"resume"}):this._controller.resume()}_onInitSegment(type,initSegment){Promise.resolve().then(()=>{this._emitter.emit(_transmuxingEvents.default.INIT_SEGMENT,type,initSegment)})}_onMediaSegment(type,mediaSegment){Promise.resolve().then(()=>{this._emitter.emit(_transmuxingEvents.default.MEDIA_SEGMENT,type,mediaSegment)})}_onLoadingComplete(){Promise.resolve().then(()=>{this._emitter.emit(_transmuxingEvents.default.LOADING_COMPLETE)})}_onRecoveredEarlyEof(){Promise.resolve().then(()=>{this._emitter.emit(_transmuxingEvents.default.RECOVERED_EARLY_EOF)})}_onMediaInfo(mediaInfo){Promise.resolve().then(()=>{this._emitter.emit(_transmuxingEvents.default.MEDIA_INFO,mediaInfo)})}_onMetaDataArrived(metadata){Promise.resolve().then(()=>{this._emitter.emit(_transmuxingEvents.default.METADATA_ARRIVED,metadata)})}_onScriptDataArrived(data){Promise.resolve().then(()=>{this._emitter.emit(_transmuxingEvents.default.SCRIPTDATA_ARRIVED,data)})}_onStatisticsInfo(statisticsInfo){Promise.resolve().then(()=>{this._emitter.emit(_transmuxingEvents.default.STATISTICS_INFO,statisticsInfo)})}_onIOError(type,info){Promise.resolve().then(()=>{this._emitter.emit(_transmuxingEvents.default.IO_ERROR,type,info)})}_onDemuxError(type,info){Promise.resolve().then(()=>{this._emitter.emit(_transmuxingEvents.default.DEMUX_ERROR,type,info)})}_onRecommendSeekpoint(milliseconds){Promise.resolve().then(()=>{this._emitter.emit(_transmuxingEvents.default.RECOMMEND_SEEKPOINT,milliseconds)})}_onLoggingConfigChanged(config){this._worker&&this._worker.postMessage({cmd:"logging_config",param:config})}_onWorkerMessage(e){var message=e.data,data=message.data;if("destroyed"===message.msg||this._workerDestroying)this._workerDestroying=!1,this._worker.terminate(),this._worker=null;else switch(message.msg){case _transmuxingEvents.default.INIT_SEGMENT:case _transmuxingEvents.default.MEDIA_SEGMENT:this._emitter.emit(message.msg,data.type,data.data);break;case _transmuxingEvents.default.LOADING_COMPLETE:case _transmuxingEvents.default.RECOVERED_EARLY_EOF:this._emitter.emit(message.msg);break;case _transmuxingEvents.default.MEDIA_INFO:Object.setPrototypeOf(data,_mediaInfo.default.prototype),this._emitter.emit(message.msg,data);break;case _transmuxingEvents.default.METADATA_ARRIVED:case _transmuxingEvents.default.SCRIPTDATA_ARRIVED:case _transmuxingEvents.default.STATISTICS_INFO:this._emitter.emit(message.msg,data);break;case _transmuxingEvents.default.IO_ERROR:case _transmuxingEvents.default.DEMUX_ERROR:this._emitter.emit(message.msg,data.type,data.info);break;case _transmuxingEvents.default.RECOMMEND_SEEKPOINT:this._emitter.emit(message.msg,data);break;case"logcat_callback":_logger.default.emitter.emit("log",data.type,data.logcat)}}}});