define(["exports","../utils/events.js","../utils/logger.js","../../browser.js","./media-info.js","../demux/flv-demuxer.js","../remux/mp4-remuxer.js","../demux/demux-errors.js","../io/io-controller.js","./transmuxing-events.js"],function(_exports,_events,_logger,_browser,_mediaInfo,_flvDemuxer,_mp4Remuxer,_demuxErrors,_ioController,_transmuxingEvents){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.default=void 0;_exports.default=class{constructor(mediaDataSource,config){this.TAG="TransmuxingController",this._emitter=new _events.default,this._config=config,mediaDataSource.segments||(mediaDataSource.segments=[{duration:mediaDataSource.duration,filesize:mediaDataSource.filesize,url:mediaDataSource.url}]),"boolean"!=typeof mediaDataSource.cors&&(mediaDataSource.cors=!0),"boolean"!=typeof mediaDataSource.withCredentials&&(mediaDataSource.withCredentials=!1),this._mediaDataSource=mediaDataSource;let totalDuration=this._currentSegmentIndex=0;this._mediaDataSource.segments.forEach(segment=>{segment.timestampBase=totalDuration,totalDuration+=segment.duration,segment.cors=mediaDataSource.cors,segment.withCredentials=mediaDataSource.withCredentials,config.referrerPolicy&&(segment.referrerPolicy=config.referrerPolicy)}),isNaN(totalDuration)||this._mediaDataSource.duration===totalDuration||(this._mediaDataSource.duration=totalDuration),this._mediaInfo=null,this._demuxer=null,this._remuxer=null,this._ioctl=null,this._pendingSeekTime=null,this._pendingResolveSeekPoint=null,this._statisticsReporter=null}destroy(){this._mediaInfo=null,this._mediaDataSource=null,this._statisticsReporter&&this._disableStatisticsReporter(),this._ioctl&&(this._ioctl.destroy(),this._ioctl=null),this._demuxer&&(this._demuxer.destroy(),this._demuxer=null),this._remuxer&&(this._remuxer.destroy(),this._remuxer=null),this._emitter.removeAllListeners(),this._emitter=null}on(event,listener){this._emitter.addListener(event,listener)}off(event,listener){this._emitter.removeListener(event,listener)}start(){this._loadSegment(0),this._enableStatisticsReporter()}_loadSegment(segmentIndex,optionalFrom){this._currentSegmentIndex=segmentIndex;var dataSource=this._mediaDataSource.segments[segmentIndex],dataSource=this._ioctl=new _ioController.default(dataSource,this._config,segmentIndex);dataSource.onError=this._onIOException.bind(this),dataSource.onSeeked=this._onIOSeeked.bind(this),dataSource.onComplete=this._onIOComplete.bind(this),dataSource.onRedirect=this._onIORedirect.bind(this),dataSource.onRecoveredEarlyEof=this._onIORecoveredEarlyEof.bind(this),optionalFrom?this._demuxer.bindDataSource(this._ioctl):dataSource.onDataArrival=this._onInitChunkArrival.bind(this),dataSource.open(optionalFrom)}stop(){this._internalAbort(),this._disableStatisticsReporter()}_internalAbort(){this._ioctl&&(this._ioctl.destroy(),this._ioctl=null)}pause(){this._ioctl&&this._ioctl.isWorking()&&(this._ioctl.pause(),this._disableStatisticsReporter())}resume(){this._ioctl&&this._ioctl.isPaused()&&(this._ioctl.resume(),this._enableStatisticsReporter())}seek(milliseconds){if(null!=this._mediaInfo&&this._mediaInfo.isSeekable()){var targetSegmentIndex=this._searchSegmentIndexContains(milliseconds);if(targetSegmentIndex===this._currentSegmentIndex){var segmentInfo=this._mediaInfo.segments[targetSegmentIndex];null==segmentInfo?this._pendingSeekTime=milliseconds:(segmentInfo=segmentInfo.getNearestKeyframe(milliseconds),this._remuxer.seek(segmentInfo.milliseconds),this._ioctl.seek(segmentInfo.fileposition),this._pendingResolveSeekPoint=segmentInfo.milliseconds)}else{segmentInfo=this._mediaInfo.segments[targetSegmentIndex];if(null==segmentInfo)this._pendingSeekTime=milliseconds,this._internalAbort(),this._remuxer.seek(),this._remuxer.insertDiscontinuity(),this._loadSegment(targetSegmentIndex);else{let keyframe=segmentInfo.getNearestKeyframe(milliseconds);this._internalAbort(),this._remuxer.seek(milliseconds),this._remuxer.insertDiscontinuity(),this._demuxer.resetMediaInfo(),this._demuxer.timestampBase=this._mediaDataSource.segments[targetSegmentIndex].timestampBase,this._loadSegment(targetSegmentIndex,keyframe.fileposition),this._pendingResolveSeekPoint=keyframe.milliseconds,this._reportSegmentMediaInfo(targetSegmentIndex)}}this._enableStatisticsReporter()}}_searchSegmentIndexContains(milliseconds){var segments=this._mediaDataSource.segments;let idx=segments.length-1;for(let i=0;i<segments.length;i++)if(milliseconds<segments[i].timestampBase){idx=i-1;break}return idx}_onInitChunkArrival(data,byteStart){var probeData;let consumed=0;return consumed=0<byteStart?(this._demuxer.bindDataSource(this._ioctl),this._demuxer.timestampBase=this._mediaDataSource.segments[this._currentSegmentIndex].timestampBase,this._demuxer.parseChunks(data,byteStart)):(probeData=_flvDemuxer.default.probe(data)).match?(this._demuxer=new _flvDemuxer.default(probeData,this._config),this._remuxer||(this._remuxer=new _mp4Remuxer.default(this._config)),probeData=this._mediaDataSource,this._demuxer.timestampBase=probeData.segments[this._currentSegmentIndex].timestampBase,this._demuxer.onError=this._onDemuxException.bind(this),this._demuxer.onMediaInfo=this._onMediaInfo.bind(this),this._demuxer.onMetaDataArrived=this._onMetaDataArrived.bind(this),this._demuxer.onScriptDataArrived=this._onScriptDataArrived.bind(this),this._remuxer.bindDataSource(this._demuxer.bindDataSource(this._ioctl)),this._remuxer.onInitSegment=this._onRemuxerInitSegmentArrival.bind(this),this._remuxer.onMediaSegment=this._onRemuxerMediaSegmentArrival.bind(this),this._demuxer.parseChunks(data,byteStart)):(_logger.default.e(this.TAG,"Non-FLV, Unsupported media type!"),Promise.resolve().then(()=>{this._internalAbort()}),this._emitter.emit(_transmuxingEvents.default.DEMUX_ERROR,_demuxErrors.default.FORMAT_UNSUPPORTED,"Non-FLV, Unsupported media type"),0)}_onMediaInfo(mediaInfo){null==this._mediaInfo&&(this._mediaInfo=Object.assign({},mediaInfo),this._mediaInfo.keyframesIndex=null,this._mediaInfo.segments=[],this._mediaInfo.segmentCount=this._mediaDataSource.segments.length,Object.setPrototypeOf(this._mediaInfo,_mediaInfo.default.prototype));mediaInfo=Object.assign({},mediaInfo);Object.setPrototypeOf(mediaInfo,_mediaInfo.default.prototype),this._mediaInfo.segments[this._currentSegmentIndex]=mediaInfo,this._reportSegmentMediaInfo(this._currentSegmentIndex),null!=this._pendingSeekTime&&Promise.resolve().then(()=>{var target=this._pendingSeekTime;this._pendingSeekTime=null,this.seek(target)})}_onMetaDataArrived(metadata){this._emitter.emit(_transmuxingEvents.default.METADATA_ARRIVED,metadata)}_onScriptDataArrived(data){this._emitter.emit(_transmuxingEvents.default.SCRIPTDATA_ARRIVED,data)}_onIOSeeked(){this._remuxer.insertDiscontinuity()}_onIOComplete(extraData){extraData+=1;extraData<this._mediaDataSource.segments.length?(this._internalAbort(),this._remuxer.flushStashedSamples(),this._loadSegment(extraData)):(this._remuxer.flushStashedSamples(),this._emitter.emit(_transmuxingEvents.default.LOADING_COMPLETE),this._disableStatisticsReporter())}_onIORedirect(redirectedURL){var segmentIndex=this._ioctl.extraData;this._mediaDataSource.segments[segmentIndex].redirectedURL=redirectedURL}_onIORecoveredEarlyEof(){this._emitter.emit(_transmuxingEvents.default.RECOVERED_EARLY_EOF)}_onIOException(type,info){_logger.default.e(this.TAG,"IOException: type = ".concat(type,", code = ").concat(info.code,", msg = ").concat(info.msg)),this._emitter.emit(_transmuxingEvents.default.IO_ERROR,type,info),this._disableStatisticsReporter()}_onDemuxException(type,info){_logger.default.e(this.TAG,"DemuxException: type = ".concat(type,", info = ").concat(info)),this._emitter.emit(_transmuxingEvents.default.DEMUX_ERROR,type,info)}_onRemuxerInitSegmentArrival(type,initSegment){this._emitter.emit(_transmuxingEvents.default.INIT_SEGMENT,type,initSegment)}_onRemuxerMediaSegmentArrival(type,mediaSegment){if(null==this._pendingSeekTime&&(this._emitter.emit(_transmuxingEvents.default.MEDIA_SEGMENT,type,mediaSegment),null!=this._pendingResolveSeekPoint)&&"video"===type){type=mediaSegment.info.syncPoints;let seekpoint=this._pendingResolveSeekPoint;this._pendingResolveSeekPoint=null,_browser.default.safari&&0<type.length&&type[0].originalDts===seekpoint&&(seekpoint=type[0].pts),this._emitter.emit(_transmuxingEvents.default.RECOMMEND_SEEKPOINT,seekpoint)}}_enableStatisticsReporter(){null==this._statisticsReporter&&(this._statisticsReporter=setInterval(this._reportStatisticsInfo.bind(this),this._config.statisticsInfoReportInterval))}_disableStatisticsReporter(){this._statisticsReporter&&(clearInterval(this._statisticsReporter),this._statisticsReporter=null)}_reportSegmentMediaInfo(segmentIndex){segmentIndex=this._mediaInfo.segments[segmentIndex],segmentIndex=Object.assign({},segmentIndex);segmentIndex.duration=this._mediaInfo.duration,segmentIndex.segmentCount=this._mediaInfo.segmentCount,delete segmentIndex.segments,delete segmentIndex.keyframesIndex,this._emitter.emit(_transmuxingEvents.default.MEDIA_INFO,segmentIndex)}_reportStatisticsInfo(){var info={};info.url=this._ioctl.currentURL,info.hasRedirect=this._ioctl.hasRedirect,info.hasRedirect&&(info.redirectedURL=this._ioctl.currentRedirectedURL),info.speed=this._ioctl.currentSpeed,info.loaderType=this._ioctl.loaderType,info.currentSegmentIndex=this._currentSegmentIndex,info.totalSegmentCount=this._mediaDataSource.segments.length,this._emitter.emit(_transmuxingEvents.default.STATISTICS_INFO,info)}}});