define(["exports", "./../modules/common/playback/playbackmanager.js", "./../modules/focusmanager.js", "./../modules/cardbuilder/cardbuilder.js", "./../modules/imageloader/imageloader.js", "./../modules/dom.js", "./../modules/browser.js", "./../modules/common/globalize.js", "./../modules/common/datetime.js", "./../modules/layoutmanager.js", "./../modules/common/itemmanager/itemmanager.js", "./../modules/loading/loading.js", "./../modules/emby-apiclient/events.js", "./../modules/emby-apiclient/connectionmanager.js", "./../modules/appheader/appheader.js", "./../modules/mediainfo/mediainfo.js", "./../modules/backdrop/backdrop.js", "./playqueue.js", "./tvplayqueue.js", "./lyrics.js", "./../modules/approuter.js", "./../modules/itemcontextmenu.js", "./../modules/shortcuts.js", "./../modules/common/inputmanager.js", "./../modules/common/usersettings/usersettings.js", "./../modules/input/mouse.js", "./../modules/emby-elements/emby-scroller/emby-scroller.js", "./../modules/emby-elements/emby-button/paper-icon-button-light.js", "./../modules/emby-elements/emby-tabs/emby-tabs.js", "./../modules/emby-elements/emby-slider/emby-slider.js", "./../modules/common/appsettings.js", "./../modules/common/servicelocator.js", "./../modules/input/keyboard.js", "./../modules/viewmanager/baseview.js"], function(_exports, _playbackmanager, _focusmanager, _cardbuilder, _imageloader, _dom, _browser, _globalize, _datetime, _layoutmanager, _itemmanager, _loading, _events, _connectionmanager, _appheader, _mediainfo, _backdrop, _playqueue, _tvplayqueue, _lyrics, _approuter, _itemcontextmenu, _shortcuts, _inputmanager, _usersettings, _mouse, _embyScroller, _paperIconButtonLight, _embyTabs, _embySlider, _appsettings, _servicelocator, _keyboard, _baseview) {
    Object.defineProperty(_exports, "__esModule", {
        value: !0
    }), _exports.default = void 0, require(["css!videoosd/videoosd.css"]);
    const useBackdropFilterForBlur = _dom.default.allowBackdropFilter(),
        headerElement = document.querySelector(".skinHeader"),
        backdropContainer = document.querySelector(".backdropContainer"),
        backgroundContainer = document.querySelector(".backgroundContainer");

    function showActionSheet(options) {
        return Emby.importModule("./modules/actionsheet/actionsheet.js").then(function(ActionSheet) {
            return ActionSheet.show(options)
        })
    }
    const enableHighResBlur = !((cores = navigator.hardwareConcurrency || 4) < 6 || (deviceMemory = navigator.deviceMemory || 2) < 2 || (platform = (navigator.platform || "").toLowerCase(), "android" === globalThis.appMode && (cores < 4 || deviceMemory < 2 || platform.includes("armv7"))));
    var deviceMemory, platform, cores;

    function isDisplayingLocalVideo(player, mediaType) {
        return !(!player || !player.isLocalPlayer) && ("Video" === mediaType || !mediaType && _playbackmanager.default.isPlayingMediaType(["Video"], player))
    }

    function getRewindIconLTR() {
        switch (_usersettings.default.skipBackLength()) {
            case 5e3:
                return "&#xe05b;";
            case 1e4:
                return "&#xe059;";
            case 3e4:
                return "&#xe05a;";
            default:
                return "&#xE042;"
        }
    }

    function getForwardIconLTR() {
        switch (_usersettings.default.skipForwardLength()) {
            case 5e3:
                return "&#xe058;";
            case 1e4:
                return "&#xe056;";
            case 3e4:
                return "&#xe057;";
            default:
                return "&#xE042;"
        }
    }

    function showMoreMenu(item, button) {
        _connectionmanager.default.getApiClient(item.ServerId).getCurrentUser().then(function(user) {
            return _itemcontextmenu.default.show(function(item, user, button) {
                return {
                    items: [item],
                    open: !1,
                    play: !1,
                    playAllFromHere: !1,
                    queueAllFromHere: !1,
                    positionTo: button,
                    cancelTimer: !1,
                    record: !1,
                    deleteItem: !1,
                    shuffle: !1,
                    instantMix: !1,
                    user: user,
                    share: !0,
                    queue: !1,
                    editSubtitles: !1,
                    positionY: "above",
                    transformOrigin: "center bottom",
                    convert: !1,
                    refreshMetadata: !1,
                    identify: !1,
                    autoTvLayout: !1
                }
            }(item, user, button))
        })
    }

    function focusMainOsdControls(instance) {
        _focusmanager.default.focus(instance.nowPlayingPositionSlider)
    }

    function hideOrShowAll(instance, elems, hide, focusedElement) {
        let wasFocused;
        for (let i = 0, length = elems.length; i < length; i++) {
            var elem = elems[i];
            hide ? (focusedElement && focusedElement === elem && (wasFocused = !0), elem.classList.add("hide")) : elem.classList.remove("hide")
        }
        wasFocused && focusMainOsdControls(instance)
    }

    function getTextActionButton(item, text) {
        return text = text || _itemmanager.default.getDisplayName(item, {}), _layoutmanager.default.tv ? text : "<button " + _shortcuts.default.getShortcutAttributesHtml(item, {}) + ' type="button" class="itemAction button-link osdTextActionButton" is="emby-button" data-action="link">' + text + "</button>"
    }

    function getSecondaryName(item, enableLinkButton) {
        var title = _itemmanager.default.getDisplayName(item, {
            includeParentInfo: "Program" !== item.Type,
            includeIndexNumber: "Program" !== item.Type
        });
        return enableLinkButton ? getTextActionButton(item, title) : title
    }

    function getDefaultOsdContentSection() {
        return _layoutmanager.default.tv || 1056 <= _dom.default.getWindowSize().innerWidth ? "playqueue" : null
    }

    function destroyPlayQueue(instance) {
        var playQueue = instance.playQueue;
        playQueue && (playQueue.destroy(), instance.playQueue = null)
    }

    function destroyLyricsRenderer(instance) {
        var lyricsRenderer = instance.lyricsRenderer;
        lyricsRenderer && (lyricsRenderer.destroy(), instance.lyricsRenderer = null)
    }

    function destroyStats(instance) {
        var statsOverlay = instance.statsOverlay;
        statsOverlay && (statsOverlay.destroy(), instance.statsOverlay = null)
    }

    function destroySubtitleOffsetOverlay(instance) {
        var subtitleOffsetOverlay = instance.subtitleOffsetOverlay;
        subtitleOffsetOverlay && (subtitleOffsetOverlay.destroy(), instance.subtitleOffsetOverlay = null)
    }

    function clearBlurFromDocumentElement() {
        document.documentElement.classList.remove("doc-nowplaying-blur"), document.documentElement.style.backgroundImage = null, backgroundContainer && (backgroundContainer.style.backgroundImage = null)
    }

    function shouldOsdBeShown(instance) {
        return !_layoutmanager.default.tv || !!instance.currentVisibleMenu || !(instance = instance.currentPlayer) || isDisplayingLocalVideo(instance)
    }
    let supportsTouchEvent = "ontouchstart" in document.documentElement;

    function rewind(instance, animate) {
        var player = instance.currentPlayer;
        animate && ((animate = instance.view.querySelector(".osd-rew-animationtext")).innerHTML = "-" + parseInt(_usersettings.default.skipBackLength() / 1e3), fadeInAndOut(animate)), _playbackmanager.default.rewind(player)
    }

    function fadeInAndOut(elem) {
        if (elem.animate) {
            var keyframes = [{
                    opacity: "1",
                    offset: .5
                }, {
                    opacity: "0",
                    transform: "none",
                    offset: 1
                }],
                timing = {
                    duration: 600,
                    iterations: 1,
                    easing: "ease-out"
                };
            try {
                elem.animate(keyframes, timing)
            } catch (err) {
                console.log("error animating element: " + err)
            }
        }
    }

    function fastForward(instance, animate) {
        var player = instance.currentPlayer;
        animate && ((animate = instance.view.querySelector(".osd-ff-animationtext")).innerHTML = "+" + parseInt(_usersettings.default.skipForwardLength() / 1e3), fadeInAndOut(animate)), _playbackmanager.default.fastForward(player)
    }

    function onOsdClick(e, instance, elementToFocusIfShowing, showOsdIfNoEvent) {
        var target = e.target;
        if (target.closest(".videoOsdBottom")) showOsdIfNoEvent && instance.showOsd();
        else if (!target.closest("button")) return target = instance.currentPlayer, !e.button && target && isDisplayingLocalVideo(target) ? (instance.showOsd(null, elementToFocusIfShowing), _playbackmanager.default.playPause(target)) : showOsdIfNoEvent && instance.showOsd(), 1
    }

    function toggleStats(instance) {
        require(["playerStats"], function(PlayerStats) {
            var player = instance.currentPlayer;
            player && (instance.statsOverlay ? instance.statsOverlay.toggle() : (instance.statsOverlay = new PlayerStats({
                player: player,
                view: instance.view
            }), _events.default.on(instance.statsOverlay, "close", function() {
                this.currentVisibleMenu && !this.upNextContainer._visible && _focusmanager.default.focus(this.btnVideoOsdSettingsRight)
            }.bind(instance))))
        })
    }

    function setBottomTabIndex(instance, index) {
        var bottomTabButtons, bottomTabs = instance.bottomTabs; - 1 === index ? bottomTabs.selectedIndex(index) : (bottomTabButtons = instance.bottomTabButtons, instance.showOsd(null, bottomTabButtons[index]), bottomTabs.selectedIndex(index), _focusmanager.default.focus(bottomTabButtons[index]))
    }

    function onRewindInputCommand(e, instance) {
        instance.currentVisibleMenu || e.detail.repeat || (rewind(instance), e.preventDefault()), shouldOsdBeShown(instance) && instance.showOsd()
    }

    function onFastForwardInputCommand(e, instance) {
        instance.currentVisibleMenu || e.detail.repeat || (fastForward(instance), e.preventDefault()), shouldOsdBeShown(instance) && instance.showOsd()
    }

    function startOsdHideTimer(instance, timeoutMs) {
        var isLocalVideo;
        stopOsdHideTimer(instance), instance.paused || !(isLocalVideo = isDisplayingLocalVideo(instance.currentPlayer)) || 0 === timeoutMs || _focusmanager.default.hasExclusiveFocusScope() || (instance.osdHideTimeout = setTimeout(instance.boundOnOsdHideTimeout, timeoutMs || (isLocalVideo ? 4e3 : 1e4)))
    }

    function stopOsdHideTimer(instance) {
        var osdHideTimeout = instance.osdHideTimeout;
        osdHideTimeout && (clearTimeout(osdHideTimeout), instance.osdHideTimeout = null)
    }
    let orientationLocked = !1;

    function onOrientationChangeSuccess() {
        orientationLocked = !0
    }

    function onOrientationChangeError(err) {
        orientationLocked = !0, console.log("error locking orientation: " + err)
    }
    let systemUIHidden;

    function setSystemUIHidden(hidden) {
        if (systemUIHidden !== hidden && (systemUIHidden = hidden, _servicelocator.appHost.setSystemUIHidden)) try {
            _servicelocator.appHost.setSystemUIHidden(hidden)
        } catch (err) {
            console.log("Error in setSystemUIHidden: " + err)
        }
    }
    let enableOrientationLock = !_browser.default.tv;

    function lockOrientation(type) {
        var _screen$orientation;
        enableOrientationLock && ! function(orientation) {
            let promise;
            try {
                return (promise = screen.orientation && screen.orientation.lock ? screen.orientation.lock(orientation) : promise) && promise.then ? promise : Promise.resolve()
            } catch (err) {
                return Promise.reject(err)
            }
        }(type = type || (null == (_screen$orientation = screen.orientation) ? void 0 : _screen$orientation.type) || "landscape").then(onOrientationChangeSuccess, onOrientationChangeError)
    }

    function unlockOrientation() {
        if (enableOrientationLock && orientationLocked && screen.orientation && screen.orientation.unlock) {
            try {
                screen.orientation.unlock()
            } catch (err) {
                console.log("error unlocking orientation: " + err)
            }
            orientationLocked = !1
        }
    }

    function VideoOsd(view, params) {
        _baseview.default.apply(this, arguments);
        let self = this,
            currentPlayerSupportedCommands = [],
            currentRuntimeTicks = 0,
            comingUpNextDisplayed, lastUpdateTime = 0,
            isEnabled, currentDisplayItem, currentDisplayChapters, currentIntroInfo, currentCreditsInfo, ratingTextNeedsUpdate = !0,
            currentMediaSource, currentItemThumbnails, currentItemThumbnailsPromise, enableProgressByTimeOfDay, programStartDateMs = 0,
            programEndDateMs = 0,
            playbackStartTimeTicks = 0;
        this.currentLockState = 0;
        let skipIntroValidated, nowPlayingVolumeSlider = view.querySelector(".videoOsdVolumeSlider"),
            videoOsdVolumeSliderWrapper = view.querySelector(".videoOsdVolumeSliderWrapper"),
            brightnessSlider = view.querySelector(".videoOsdBrightnessSlider"),
            brightnessSliderContainer = view.querySelector(".brightnessSliderContainer"),
            videoOsdPositionText = (this.nowPlayingPositionSlider = view.querySelector(".videoOsdPositionSlider"), view.querySelector(".videoOsdPositionText")),
            videoOsdDurationText = view.querySelector(".videoOsdDurationText"),
            rewindButtons = view.querySelectorAll(".btnRewind"),
            fastForwardButtons = view.querySelectorAll(".btnOsdFastForward"),
            stopButtons = (this.btnPause = view.querySelector(".videoOsd-btnPause"), view.querySelectorAll(".btnVideoOsd-stop")),
            btnRepeatMode = view.querySelector(".btnOsdRepeatMode"),
            btnOsdMoreBottom = view.querySelector(".btnOsdMore-bottom"),
            btnOsdMoreTitle = view.querySelector(".btnOsdMore-title");
        var itemsContainer, transitionEndEventName = _dom.default.whichTransitionEvent();
        this.osdBottomElement = view.querySelector(".videoOsdBottom");
        let btnPreviousTrack = view.querySelector(".btnPreviousTrack"),
            btnNextTrack = view.querySelector(".btnNextTrack"),
            buttonMute = view.querySelector(".buttonMute"),
            btnSubtitles = view.querySelector(".btnSubtitles"),
            btnAudio = view.querySelector(".btnAudio"),
            btnFullscreen = view.querySelector(".btnFullscreen"),
            videoOsdSecondaryText = view.querySelector(".videoOsdSecondaryText"),
            videoOsdBottomButtons = (this.videoOsdText = view.querySelector(".videoOsdText"), view.querySelector(".videoOsdBottom-buttons")),
            mainTransportButtons = view.querySelector(".videoOsd-maintransportbuttons"),
            videoOsdPositionContainer = view.querySelector(".videoOsdPositionContainer"),
            osdTitle = view.querySelector(".videoOsdTitle"),
            videoOsdThirdTitle = view.querySelector(".videoOsdThirdTitle"),
            videoOsdParentTitle = view.querySelector(".videoOsdParentTitle-small"),
            videoOsdParentTitleLarge = view.querySelector(".videoOsdParentTitle-large"),
            osdPosterContainer = view.querySelector(".osdPosterContainer"),
            videoOsdSecondaryMediaInfo = view.querySelector(".videoOsdSecondaryMediaInfo"),
            videoOsdAudioInfo = view.querySelector(".videoOsd-audioInfo"),
            mainLockButton = view.querySelector(".videoOsd-btnLock"),
            tabContainers = (this.bottomTabs = view.querySelector(".videoOsdBottom-tabs"), this.bottomTabButtons = view.querySelectorAll(".videoosd-tab-button"), view.querySelectorAll(".videoosd-tab")),
            btnCloseTabContent = (this.bottomTabControllers = [], this.bottomTabControllers.length = tabContainers.length, view.querySelector(".btnCloseTabContent")),
            tabContainersElem = view.querySelector(".videoosd-tabcontainers"),
            videoOsdBottomContentbuttons = view.querySelector(".videoOsdBottom-contentbuttons"),
            videoOsdBottomMaincontrols = (this.upNextContainer = view.querySelector(".upNextContainer"), view.querySelector(".videoOsdBottom-maincontrols")),
            videoOsdVolumeControls = view.querySelector(".videoOsdVolumeControls"),
            videoOsdButtomButtonsTopRight = view.querySelector(".videoOsdBottom-buttons-topright"),
            ratingInfoContainer = view.querySelector(".videoOsd-ratingInfo"),
            ratingTextElement = view.querySelector(".videoOsd-ratingText"),
            btnSkipIntro = view.querySelector(".btnSkipIntro"),
            skipIntroContainer = view.querySelector(".skipIntroContainer"),
            btnLyrics = view.querySelector(".btnLyrics"),
            btnVideoOsdSettingsTransportButton = (this.btnRecord = view.querySelector(".btnRecord"), this.btnVideoOsdSettingsRight = view.querySelector(".btnVideoOsdSettings-right"), view.querySelector(".btnVideoOsdSettings-transport")),
            btnPlayNextFromUpNextProgress = view.querySelector(".btnPlayNextFromUpNext-progress"),
            btnHideUpNext = view.querySelector(".btnHideUpNext"),
            enableSkipIntro = !0,
            enableAutoSkipIntro, lastPointerUpType;
        _layoutmanager.default.tv ? videoOsdBottomButtons.classList.add("videoOsdBottom-buttons-tv") : (videoOsdPositionText.classList.add("videoOsd-customFont-x0"), videoOsdDurationText.classList.add("videoOsd-customFont-x0"), ratingTextElement.classList.add("videoOsd-customFont-x2"), videoOsdBottomButtons.classList.add("videoOsd-customFont-x2"), videoOsdButtomButtonsTopRight.classList.add("videoOsd-customFont-x2"), skipIntroContainer.classList.add("videoOsd-customFont-x2"), this.upNextContainer.classList.add("videoOsd-customFont-x2"), this.osdBottomElement.classList.add("videoOsd-nobuttonmargin"));
        let currentOsdContentSectionName;
        for (let i = 0, length = fastForwardButtons.length; i < length; i++) {
            icon = btnFastForward = void 0;
            var btnFastForward = fastForwardButtons[i],
                icon = btnFastForward.querySelector("i");
            switch (icon.innerHTML = ("rtl" === document.dir ? getRewindIconLTR : getForwardIconLTR)(), _usersettings.default.skipForwardLength()) {
                case 5e3:
                case 1e4:
                case 3e4:
                    break;
                default:
                    icon.classList.add("videoOsd-forwardIcon-flipped")
            }
        }
        for (let i = 0, length = rewindButtons.length; i < length; i++) rewindButtons[i].querySelector("i").innerHTML = ("rtl" === document.dir ? getForwardIconLTR : getRewindIconLTR)();

        function updateRecordingButton(item, user) {
            item && "Program" === item.Type ? user.Policy.EnableLiveTvManagement && require(["recordingButton"], function(RecordingButton) {
                let recordingButtonManager = self.recordingButtonManager;
                recordingButtonManager ? recordingButtonManager.refreshItem(item) : (recordingButtonManager = self.recordingButtonManager = new RecordingButton({
                    item: item,
                    button: self.btnRecord
                }), self.btnRecord.classList.remove("hide"))
            }) : ((user = self.recordingButtonManager) && (user.destroy(), self.recordingButtonManager = null), self.btnRecord.classList.add("hide"))
        }

        function updateButtomTabsVisibility(state, item, displayItem) {
            var apiClient;
            item ? (apiClient = _connectionmanager.default.getApiClient(item), ("Video" === item.MediaType ? apiClient.getUserViews({}, apiClient.getCurrentUserId()) : Promise.resolve({
                Items: []
            })).then(function(result) {
                var bottomTabButtons = self.bottomTabButtons,
                    result = ("Video" === item.MediaType ? bottomTabButtons[0].classList.remove("hide") : bottomTabButtons[0].classList.add("hide"), currentDisplayChapters && currentDisplayChapters.length ? bottomTabButtons[1].classList.remove("hide") : bottomTabButtons[1].classList.add("hide"), displayItem.People && displayItem.People.length ? bottomTabButtons[2].classList.remove("hide") : bottomTabButtons[2].classList.add("hide"), ! function(userViews) {
                        for (let i = 0, length = userViews.length; i < length; i++)
                            if ("livetv" === userViews[i].CollectionType) return 1
                    }(result.Items) ? (bottomTabButtons[3].classList.add("hide"), bottomTabButtons[4].classList.add("hide")) : (bottomTabButtons[3].classList.remove("hide"), bottomTabButtons[4].classList.remove("hide")), self.bottomTabs),
                    selectedIndex = (view.querySelector(".videoosd-tab-button:not(.hide)") ? (tabContainersElem.classList.remove("hide"), result.classList.remove("hide")) : (tabContainersElem.classList.add("hide"), result.classList.add("hide")), result.selectedIndex());
                0 <= selectedIndex && (bottomTabButtons[selectedIndex].classList.contains("hide") ? result.selectedIndex(-1) : loadBottomTabController(selectedIndex, !0))
            })) : (self.bottomTabs.selectedIndex(-1), tabContainersElem.classList.add("hide"), self.bottomTabs.classList.add("hide"))
        }

        function updateDisplayItem(state, itemInfo, user) {
            var item = itemInfo.originalItem,
                itemInfo = (self.currentItem = item, currentItemThumbnailsPromise = null, currentItemThumbnails = null, itemInfo.displayItem || item),
                user = (currentDisplayItem = itemInfo, currentDisplayChapters = function(chapters) {
                    var list = [];
                    for (let i = 0, length = chapters.length; i < length; i++) {
                        var chapter = chapters[i];
                        chapter.MarkerType && "Chapter" !== chapter.MarkerType || list.push(chapter)
                    }
                    return list
                }(itemInfo.Chapters || []), updateRecordingButton(itemInfo, user), self.currentPlayer),
                user = isDisplayingLocalVideo(user, item.MediaType);
            updateButtomTabsVisibility(0, item, itemInfo);
            let primaryNameText, primaryNameHtml;
            itemInfo.EpisodeTitle || itemInfo.IsSeries ? primaryNameText = itemInfo.Name : itemInfo.SeriesName ? (primaryNameText = itemInfo.SeriesName, itemInfo.SeriesId && !user && (primaryNameHtml = getTextActionButton({
                    Id: itemInfo.SeriesId,
                    Type: "Series",
                    IsFolder: !0,
                    ServerId: itemInfo.ServerId,
                    Name: itemInfo.SeriesName,
                    ParentId: itemInfo.ParentId
                }))) : itemInfo.ArtistItems && itemInfo.ArtistItems.length && (primaryNameText = itemInfo.Name, primaryNameHtml = function(displayItem) {
                    var html = [],
                        artistItems = displayItem.ArtistItems;
                    if (artistItems)
                        for (let i = 0, length = artistItems.length; i < length; i++) html.push(getTextActionButton({
                            Id: artistItems[i].Id,
                            ServerId: displayItem.ServerId,
                            Name: artistItems[i].Name,
                            Type: "MusicArtist",
                            IsFolder: !0
                        }));
                    return html
                }(itemInfo).join(", ")), primaryNameHtml = primaryNameHtml || primaryNameText,
                function(item, originalItem, title) {
                    _appheader.default.setLogoTitle({
                        items: [item, originalItem],
                        titleText: "",
                        preferredLogoImageTypes: ["LogoLightColor", "LogoLight", "Logo"]
                    });
                    originalItem = title || (item ? item.Name : null);
                    originalItem && (document.title = originalItem)
                }(itemInfo, item, primaryNameText),
                function(displayItem, item, displayingLocalVideo, mediaType) {
                    let backdropItems = [displayItem];
                    if (item.Id !== displayItem.Id && backdropItems.push(item), displayingLocalVideo) _backdrop.default.setBackdrops(backdropItems), view.classList.add("darkContentContainer", "graphicContentContainer"), headerElement.classList.add("headroom-scrolling"), clearBlurFromDocumentElement(self);
                    else {
                        displayItem = "Video" === mediaType ? "nowPlayingVideoBackgroundStyle" : "nowPlayingAudioBackgroundStyle";
                        if ("blur" === _usersettings.default[displayItem]() && (item = (backdropItems = getDetailImageItemsSync().Items)[0])) {
                            displayingLocalVideo = _imageloader.default.getImageUrl(item, _connectionmanager.default.getApiClient(item), {
                                width: 100,
                                adjustForPixelRatio: !1
                            }).imgUrl;
                            if (displayingLocalVideo) return _backdrop.default.setBackdrop(displayingLocalVideo), displayingLocalVideo ? (view.classList.add("darkContentContainer"), view.classList.remove("graphicContentContainer"), headerElement.classList.remove("headroom-scrolling"), document.documentElement.classList.add("doc-nowplaying-blur")) : (view.classList.remove("darkContentContainer", "graphicContentContainer"), headerElement.classList.remove("headroom-scrolling"), clearBlurFromDocumentElement(self))
                        }
                        _backdrop.default.setBackdrops(backdropItems), clearBlurFromDocumentElement(self), headerElement.classList.remove("headroom-scrolling"), _backdrop.default.hasBackdrop() ? view.classList.add("darkContentContainer", "graphicContentContainer") : view.classList.remove("darkContentContainer", "graphicContentContainer")
                    }
                }(itemInfo, item, user, item.MediaType), user ? setPoster(null) : setPoster(itemInfo), titleElement = osdTitle;
            let secondaryName;
            secondaryName = "Audio" === item.MediaType ? (secondaryName = getSecondaryName(itemInfo, !1), item = primaryNameHtml, primaryNameHtml = secondaryName, item) : getSecondaryName(itemInfo, !user), primaryNameHtml || (primaryNameHtml = secondaryName, secondaryName = null), videoOsdParentTitle.innerHTML = primaryNameHtml, (videoOsdParentTitleLarge.innerHTML = primaryNameHtml) ? videoOsdSecondaryText.classList.add("videoOsdSecondaryText-withparentname") : videoOsdSecondaryText.classList.remove("videoOsdSecondaryText-withparentname"), secondaryName || itemInfo.Type, (titleElement.innerHTML = secondaryName) ? titleElement.classList.remove("hide") : titleElement.classList.add("hide");
            item = videoOsdSecondaryMediaInfo;
            let secondaryMediaInfoHtml;
            secondaryMediaInfoHtml = "Audio" === itemInfo.MediaType || "Program" !== itemInfo.Type && !secondaryName ? _mediainfo.default.getMediaInfoHtml(itemInfo, {
                    runtime: !1,
                    endsAt: !1,
                    container: !user,
                    year: "Audio" !== itemInfo.MediaType,
                    CommunityRating: !1,
                    criticRating: !1
                }) : _mediainfo.default.getSecondaryMediaInfoHtml(itemInfo, {
                    startDate: !1,
                    programTime: !1
                }), "Audio" === itemInfo.MediaType && itemInfo.Album && itemInfo.AlbumId ? (videoOsdThirdTitle.innerHTML = getTextActionButton({
                    Type: "MusicAlbum",
                    Id: itemInfo.AlbumId,
                    ServerId: itemInfo.ServerId,
                    Name: itemInfo.Album
                }), videoOsdThirdTitle.classList.remove("hide")) : videoOsdThirdTitle.classList.add("hide"),
                function(item) {
                    var mediaStreams = ((((item = item && "Audio" !== item.MediaType ? null : item) || {}).MediaSources || [])[0] || {}).MediaStreams || [];
                    for (let i = 0, length = mediaStreams.length; i < length; i++)
                        if ("Subtitle" === mediaStreams[i].Type) return btnLyrics.classList.remove("hide");
                    btnLyrics.classList.add("hide"), "lyrics" === currentOsdContentSectionName && setContentSection(getDefaultOsdContentSection(), !1)
                }(itemInfo), item.innerHTML = secondaryMediaInfoHtml, (videoOsdAudioInfo.innerHTML = secondaryMediaInfoHtml) ? "Audio" === itemInfo.MediaType ? (item.classList.add("hide"), videoOsdAudioInfo.classList.remove("hide")) : (item.classList.remove("hide"), videoOsdAudioInfo.classList.add("hide")) : (item.classList.add("hide"), videoOsdAudioInfo.classList.add("hide")), programEndDateMs = enableProgressByTimeOfDay ? (setDisplayTime(videoOsdPositionText, itemInfo.StartDate), setDisplayTime(videoOsdDurationText, itemInfo.EndDate), programStartDateMs = itemInfo.StartDate ? _datetime.default.parseISO8601Date(itemInfo.StartDate).getTime() : 0, itemInfo.EndDate ? _datetime.default.parseISO8601Date(itemInfo.EndDate).getTime() : 0) : programStartDateMs = 0;
            var titleElement = self.lyricsRenderer,
                chapters = (titleElement && titleElement.updateItem(itemInfo), itemInfo.Chapters || []);
            let introStart, introEnd, creditsStart;
            for (let i = 0, length = chapters.length; i < length; i++) {
                var chapter = chapters[i];
                "IntroStart" === chapter.MarkerType ? (introStart = chapter.StartPositionTicks, i < chapters.length - 1 && (introEnd = chapters[i + 1].StartPositionTicks)) : "IntroEnd" === chapter.MarkerType ? introEnd = chapter.StartPositionTicks : "CreditsStart" === chapter.MarkerType && (creditsStart = chapter.StartPositionTicks)
            }
            creditsStart && (user = introEnd || introStart) && user >= creditsStart && (creditsStart = null), currentIntroInfo = null != introStart && introEnd ? {
                start: introStart,
                end: introEnd
            } : null, currentCreditsInfo = null != creditsStart ? {
                start: creditsStart
            } : null;
            var bottomTabControllers = self.bottomTabControllers;
            for (let i = 0, length = bottomTabControllers.length; i < length; i++) bottomTabControllers[i] && bottomTabControllers[i].onItemUpdated({
                item: self.currentItem,
                displayItem: currentDisplayItem,
                mediaSource: currentMediaSource
            })
        }

        function getDisplayTimeWithoutAmPm(date, showSeconds) {
            return (showSeconds ? _datetime.default.toLocaleTimeString(date, {
                hour: "numeric",
                minute: "2-digit",
                second: "2-digit"
            }) : _datetime.default.getDisplayTime(date)).toLowerCase().replace("am", "").replace("pm", "").trim()
        }

        function setDisplayTime(elem, date) {
            let html;
            date && (date = _datetime.default.parseISO8601Date(date), html = getDisplayTimeWithoutAmPm(date)), elem.innerHTML = html || ""
        }

        function supportsSubtitleDownloading() {
            return currentPlayerSupportedCommands.includes("RefreshMediaSource")
        }

        function updateNowPlayingInfo(event, player, state) {
            let item = state.NowPlayingItem;
            if (self.currentItem = item, currentItemThumbnailsPromise = null, currentItemThumbnails = null, item) {
                currentMediaSource = state.MediaSource, (enableProgressByTimeOfDay = function(item, mediaSource) {
                    return !("TvChannel" !== item.Type || !item.CurrentProgram || !mediaSource || mediaSource.RunTimeTicks)
                }(item, state.MediaSource)) ? self.nowPlayingPositionSlider.getTrackBackgroundUpper().classList.add("emby-slider-background-upper-accent") : self.nowPlayingPositionSlider.getTrackBackgroundUpper().classList.remove("emby-slider-background-upper-accent");
                let apiClient = _connectionmanager.default.getApiClient(item);
                Promise.all([function(item, currentDisplayItem) {
                    return item.Id ? currentDisplayItem && currentDisplayItem.Id === item.Id ? Promise.resolve({
                        originalItem: currentDisplayItem,
                        displayItem: currentDisplayItem.CurrentProgram || currentDisplayItem
                    }) : (currentDisplayItem = _connectionmanager.default.getApiClient(item.ServerId)).getItem(currentDisplayItem.getCurrentUserId(), item.Id).then(function(refreshedItem) {
                        return {
                            originalItem: refreshedItem,
                            displayItem: refreshedItem.CurrentProgram || refreshedItem
                        }
                    }) : Promise.resolve({
                        originalItem: item
                    })
                }(item, currentDisplayItem), apiClient.getCurrentUser()]).then(function(responses) {
                    var user = responses[1];
                    if (updateDisplayItem(0, responses[0], user), nowPlayingVolumeSlider.disabled = !1, self.nowPlayingPositionSlider.disabled = !0 === state.IsInitialRequest, "Video" === item.MediaType || item.SupportsResume) {
                        for (let i = 0, length = fastForwardButtons.length; i < length; i++) fastForwardButtons[i].classList.remove("hide"), fastForwardButtons[i].disabled = !0 === state.IsInitialRequest;
                        for (let i = 0, length = rewindButtons.length; i < length; i++) rewindButtons[i].classList.remove("hide"), rewindButtons[i].disabled = !0 === state.IsInitialRequest
                    } else {
                        for (let i = 0, length = fastForwardButtons.length; i < length; i++) fastForwardButtons[i].classList.add("hide");
                        for (let i = 0, length = rewindButtons.length; i < length; i++) rewindButtons[i].classList.add("hide")
                    }
                    1 < _playbackmanager.default.audioTracks(player).length ? btnAudio.classList.remove("hide") : btnAudio.classList.add("hide"), enableSkipIntro = "None" !== user.Configuration.IntroSkipMode, enableAutoSkipIntro = "AutoSkip" === user.Configuration.IntroSkipMode, enableSkipIntro && validateSkipIntroFeature({
                        showDialog: !1
                    }, !0), _playbackmanager.default.subtitleTracks(player).length || _itemmanager.default.canDownloadSubtitles(item, user) && supportsSubtitleDownloading(apiClient) ? btnSubtitles.classList.remove("hide") : btnSubtitles.classList.add("hide")
                })
            } else {
                currentDisplayItem = null, currentDisplayChapters = null, currentIntroInfo = null, currentCreditsInfo = null, ratingTextNeedsUpdate = !0, setPoster(currentMediaSource = null), updateRecordingButton(null), _appheader.default.setTitle(""), nowPlayingVolumeSlider.disabled = !0, self.nowPlayingPositionSlider.disabled = !0;
                for (let i = 0, length = fastForwardButtons.length; i < length; i++) fastForwardButtons[i].classList.add("hide");
                for (let i = 0, length = rewindButtons.length; i < length; i++) rewindButtons[i].classList.add("hide");
                btnSubtitles.classList.add("hide"), btnAudio.classList.add("hide"), ratingInfoContainer.classList.add("hide"), updateButtomTabsVisibility(0, null, null), osdTitle.innerHTML = "", view.querySelector(".videoOsdMediaInfo").innerHTML = ""
            }
        }

        function setPoster(item) {
            var posterContainer = osdPosterContainer;
            item ? (posterContainer.classList.remove("hide"), posterContainer.resume({
                refresh: !0
            })) : (posterContainer.classList.add("hide"), posterContainer.innerHTML = "")
        }
        let nowPlayingSliderValue = 0,
            nowPlayingSliderRunTimeTicks = 0,
            endEditTimeoutForPositionSlider;

        function endEditsForPositionSlider() {
            self.nowPlayingPositionSlider.endEditing(!0, nowPlayingSliderValue)
        }

        function clearEndEditTimeoutForPositionSlider() {
            endEditTimeoutForPositionSlider && (clearTimeout(endEditTimeoutForPositionSlider), endEditTimeoutForPositionSlider = null)
        }

        function startEndEditTimeoutForPositionSlider() {
            clearEndEditTimeoutForPositionSlider(), endEditTimeoutForPositionSlider = setTimeout(endEditsForPositionSlider, 800)
        }

        function convertMsToNowPlayingSliderStep(ms) {
            var runtimeTicks = nowPlayingSliderRunTimeTicks;
            return runtimeTicks ? 1e4 * ms / runtimeTicks * 100 : self.nowPlayingPositionSlider.step
        }

        function cancelPositionSliderEditing() {
            clearEndEditTimeoutForPositionSlider();
            var elem = self.nowPlayingPositionSlider;
            elem.dragging && elem.cancelEditing()
        }

        function updateFullscreenIcon() {
            let title;
            _playbackmanager.default.isFullscreen(self.currentPlayer) ? (title = _globalize.default.translate("ExitFullscreen"), btnFullscreen.querySelector("i").innerHTML = "&#xE5D1;") : (title = _globalize.default.translate("Fullscreen"), btnFullscreen.querySelector("i").innerHTML = "&#xE5D0;"), btnFullscreen.title = title, btnFullscreen.setAttribute("aria-label", title)
        }

        function updateTransparency(player, state, mediaType) {
            var isLocalVideo = isDisplayingLocalVideo(player, mediaType),
                videoOsdText = (console.log("updateTransparency: isLocalVideo:" + isLocalVideo + ", mediaType:" + mediaType), _layoutmanager.default.tv ? videoOsdSecondaryText.classList.add("videoOsdSecondaryText-tv") : videoOsdSecondaryText.classList.remove("videoOsdSecondaryText-tv"), self.videoOsdText),
                bottomTabs = self.bottomTabs,
                osdBottomElement = self.osdBottomElement;
            let hideTransportButtons;
            if (isLocalVideo) {
                if (!player.isLocalPlayer || player.isExternalPlayer || state.IsBackgroundPlayback) unlockOrientation(), setSystemUIHidden(!1);
                else {
                    switch (_usersettings.default.videoOrientation()) {
                        case "device":
                            unlockOrientation();
                            break;
                        case "landscape":
                            lockOrientation("landscape");
                            break;
                        default:
                            lockOrientation("any")
                    }
                    setSystemUIHidden(!0)
                }
                self.currentVisibleMenu || (headerElement.classList.add("videoOsdHeader-hidden", "hide"), osdBottomElement.classList.add("hide", "videoOsdBottom-hidden")), osdBottomElement.classList.add("videoOsdBottom-video"), osdPosterContainer.classList.remove("osdPosterContainer-autoexpand"), videoOsdSecondaryText.classList.remove("videoOsdSecondaryText-remotecontrol"), videoOsdBottomMaincontrols.classList.remove("videoOsdBottomMaincontrols-autoexpand"), videoOsdPositionContainer.classList.remove("videoOsdPositionContainer-autosmall"), videoOsdPositionContainer.classList.add("focuscontainer-x"), _layoutmanager.default.tv ? (function() {
                    var val;
                    if (!_usersettings.default.enableVideoUnderUI()) return "true" === (val = _usersettings.default.hideMediaTransportButtons()) ? 1 : "false" !== val && !_mouse.default.lastMouseInputTime()
                }() && (hideTransportButtons = !0), mainLockButton.classList.add("hide")) : mainLockButton.classList.remove("hide"), videoOsdButtomButtonsTopRight.classList.remove("videoOsdBottom-buttons-topright-remotecontrol", "videoOsdBottom-buttons-topright-remotecontrol-tv"), tabContainersElem.classList.remove("videoosd-tabcontainers-autosmall"), bottomTabs.classList.remove("videoOsdBottom-tabs-remotecontrol"), videoOsdVolumeControls.classList.add("videoOsdVolumeControls-showhover", "videoOsdVolumeControls-hidetouch"), videoOsdParentTitle.classList.add("hide"), videoOsdParentTitleLarge.classList.remove("hide"), state.IsInitialRequest ? _approuter.default.setTransparency(0) : _approuter.default.setTransparency("full"), hideOrShowAll(self, stopButtons, !_layoutmanager.default.tv || !_usersettings.default.enableVideoUnderUI(), null), videoOsdText.classList.remove("videoOsdText-remotecontrol", "videoOsdText-autosmall", "videoOsdText-remotecontrol-tv"), videoOsdBottomButtons.classList.remove("videoOsdBottom-buttons-remotecontrol", "videoOsdBottom-buttons-remotecontrol-tv"), osdBottomElement.classList.remove("videoOsdBottom-remotecontrol", "videoOsdBottom-safe", "padded-top-page", "videoOsdBottom-tvnowplaying"), view.classList.remove("justify-content-flex-end"), osdTitle.classList.remove("secondaryText"), videoOsdSecondaryMediaInfo.classList.remove("videoOsdSecondaryMediaInfo-remotecontrol"), videoOsdPositionText.classList.remove("videoOsd-customFont-remotecontrol"), videoOsdDurationText.classList.remove("videoOsd-customFont-remotecontrol"), videoOsdBottomButtons.classList.remove("videoOsd-customFont-remotecontrol", "videoOsd-customFont-remotecontrol-buttons"), videoOsdButtomButtonsTopRight.classList.remove("videoOsd-customFont-remotecontrol", "videoOsd-customFont-remotecontrol-buttons"), headerElement.classList.remove("videoOsd-customFont-remotecontrol", "videoosd-header-safe"), videoOsdBottomContentbuttons.classList.add("hide"), videoOsdBottomContentbuttons.classList.remove("focusable", "videoOsd-customFont-remotecontrol-buttons", "videoOsd-customFont-remotecontrol", "videoOsd-customFont-remotecontrol-buttons", "videoOsdBottom-contentbuttons-tv"), videoOsdVolumeSliderWrapper.classList.remove("videoOsdVolumeSliderWrapper-customfont"), buttonMute.classList.remove("btnMuteOSD-remotecontrol"), videoOsdPositionContainer.classList.remove("videoOsdPositionContainer-limitwidth"), backdropContainer.classList.remove("nowplaying-backdropcontainer-blur", "nowplaying-backdropcontainer-blur-high", "nowplaying-backdropcontainer-blur-extrasaturation", "nowplaying-backdropcontainer-blur-backdropfilter"), backgroundContainer.classList.remove("nowplaying-backgroundcontainer-blur", "nowplaying-backgroundcontainer-blur-backdropfilter"), backgroundContainer.classList.remove("nowplaying-backgroundcontainer-brighter"), self.enableStopOnBack = !0, self.enableBackOnStop = !0, btnOsdMoreTitle.classList.add("hide"), btnOsdMoreBottom.classList.add("hide")
            } else unlockOrientation(), setSystemUIHidden(!1), osdTitle.classList.add("secondaryText"), osdBottomElement.classList.remove("videoOsdBottom-video", "videoOsdBottom-hidden", "hide", "videoosd-withupnext"), self.showOsd(), "blur" === _usersettings.default["Video" === mediaType ? "nowPlayingVideoBackgroundStyle" : "nowPlayingAudioBackgroundStyle"]() ? (backdropContainer.classList.add("nowplaying-backdropcontainer-blur"), enableHighResBlur && backdropContainer.classList.add("nowplaying-backdropcontainer-blur-high"), _browser.default.chrome ? backdropContainer.classList.add("nowplaying-backdropcontainer-blur-extrasaturation") : backdropContainer.classList.remove("nowplaying-backdropcontainer-blur-extrasaturation"), backgroundContainer.classList.add("nowplaying-backgroundcontainer-blur"), useBackdropFilterForBlur && (backgroundContainer.classList.add("nowplaying-backgroundcontainer-blur-backdropfilter"), backdropContainer.classList.add("nowplaying-backdropcontainer-blur-backdropfilter")), backgroundContainer.classList.remove("nowplaying-backgroundcontainer-brighter")) : (backdropContainer.classList.remove("nowplaying-backdropcontainer-blur", "nowplaying-backdropcontainer-blur-high", "nowplaying-backdropcontainer-blur-extrasaturation", "nowplaying-backdropcontainer-blur-backdropfilter"), backgroundContainer.classList.remove("nowplaying-backgroundcontainer-blur", "nowplaying-backgroundcontainer-blur-backdropfilter"), backgroundContainer.classList.add("nowplaying-backgroundcontainer-brighter")), videoOsdParentTitleLarge.classList.add("hide"), videoOsdParentTitle.classList.remove("hide"), videoOsdSecondaryMediaInfo.classList.add("videoOsdSecondaryMediaInfo-remotecontrol"), mainLockButton.classList.add("hide"), headerElement.classList.add("videoosd-header-safe"), _layoutmanager.default.tv ? (osdBottomElement.classList.add("videoOsdBottom-safe", "padded-top-page", "videoOsdBottom-tvnowplaying", "videoOsdBottom-remotecontrol"), view.classList.remove("justify-content-flex-end"), videoOsdText.classList.add("videoOsdText-remotecontrol", "videoOsdText-remotecontrol-tv"), videoOsdText.classList.remove("videoOsdText-autosmall"), osdPosterContainer.classList.remove("osdPosterContainer-autoexpand"), videoOsdSecondaryText.classList.add("videoOsdSecondaryText-remotecontrol"), videoOsdBottomButtons.classList.remove("videoOsdBottom-buttons-remotecontrol", "videoOsd-customFont-remotecontrol", "videoOsd-customFont-remotecontrol-buttons"), videoOsdBottomButtons.classList.add("videoOsdBottom-buttons-remotecontrol-tv"), videoOsdBottomMaincontrols.classList.remove("videoOsdBottomMaincontrols-autoexpand"), videoOsdPositionContainer.classList.add("focuscontainer-x"), videoOsdPositionContainer.classList.remove("videoOsdPositionContainer-autosmall"), tabContainersElem.classList.remove("videoosd-tabcontainers-autosmall"), bottomTabs.classList.add("videoOsdBottom-tabs-remotecontrol"), videoOsdPositionText.classList.remove("videoOsd-customFont-remotecontrol"), videoOsdDurationText.classList.remove("videoOsd-customFont-remotecontrol"), headerElement.classList.remove("videoOsd-customFont-remotecontrol"), videoOsdBottomContentbuttons.classList.add("focusable", "videoOsdBottom-contentbuttons-tv"), videoOsdBottomContentbuttons.classList.remove("hide", "videoOsd-customFont-remotecontrol-buttons", "videoOsd-customFont-remotecontrol", "videoOsd-customFont-remotecontrol-buttons"), videoOsdVolumeSliderWrapper.classList.remove("videoOsdVolumeSliderWrapper-customfont"), videoOsdVolumeControls.classList.add("videoOsdVolumeControls-showhover", "videoOsdVolumeControls-hidetouch"), buttonMute.classList.remove("btnMuteOSD-remotecontrol"), videoOsdButtomButtonsTopRight.classList.remove("videoOsd-customFont-remotecontrol", "videoOsd-customFont-remotecontrol-buttons", "videoOsdBottom-buttons-topright-remotecontrol"), videoOsdButtomButtonsTopRight.classList.add("videoOsdBottom-buttons-topright-remotecontrol-tv"), btnOsdMoreTitle.classList.add("hide"), btnOsdMoreBottom.classList.remove("hide")) : (osdBottomElement.classList.add("videoOsdBottom-remotecontrol", "videoOsdBottom-safe", "padded-top-page"), view.classList.remove("justify-content-flex-end"), osdPosterContainer.classList.add("osdPosterContainer-autoexpand"), videoOsdText.classList.add("videoOsdText-remotecontrol", "videoOsdText-autosmall"), videoOsdText.classList.remove("videoOsdText-remotecontrol-tv"), videoOsdBottomMaincontrols.classList.add("videoOsdBottomMaincontrols-autoexpand"), videoOsdPositionContainer.classList.add("videoOsdPositionContainer-autosmall"), videoOsdPositionContainer.classList.remove("focuscontainer-x"), tabContainersElem.classList.add("videoosd-tabcontainers-autosmall"), bottomTabs.classList.add("videoOsdBottom-tabs-remotecontrol"), videoOsdSecondaryText.classList.add("videoOsdSecondaryText-remotecontrol"), videoOsdBottomButtons.classList.add("videoOsdBottom-buttons-remotecontrol"), videoOsdBottomButtons.classList.remove("videoOsdBottom-buttons-remotecontrol-tv"), videoOsdPositionText.classList.add("videoOsd-customFont-remotecontrol"), videoOsdDurationText.classList.add("videoOsd-customFont-remotecontrol"), videoOsdBottomButtons.classList.add("videoOsd-customFont-remotecontrol", "videoOsd-customFont-remotecontrol-buttons"), videoOsdButtomButtonsTopRight.classList.add("videoOsd-customFont-remotecontrol", "videoOsd-customFont-remotecontrol-buttons"), headerElement.classList.add("videoOsd-customFont-remotecontrol"), videoOsdBottomContentbuttons.classList.remove("hide", "videoOsdBottom-contentbuttons-tv"), videoOsdBottomContentbuttons.classList.add("focusable", "videoOsd-customFont-remotecontrol-buttons", "videoOsd-customFont-remotecontrol"), videoOsdVolumeSliderWrapper.classList.add("videoOsdVolumeSliderWrapper-customfont"), videoOsdVolumeControls.classList.remove("videoOsdVolumeControls-showhover", "videoOsdVolumeControls-hidetouch"), buttonMute.classList.add("btnMuteOSD-remotecontrol"), videoOsdButtomButtonsTopRight.classList.add("videoOsdBottom-buttons-topright-remotecontrol"), videoOsdButtomButtonsTopRight.classList.remove("videoOsdBottom-buttons-topright-remotecontrol-tv"), videoOsdPositionContainer.classList.add("videoOsdPositionContainer-limitwidth"), btnOsdMoreTitle.classList.remove("hide"), btnOsdMoreBottom.classList.add("hide")), _approuter.default.setTransparency(0), hideOrShowAll(self, stopButtons, !1, null), self.enableStopOnBack = !1, self.enableBackOnStop = !0;
            if (hideTransportButtons ? (videoOsdBottomButtons.classList.add("hide"), videoOsdBottomButtons.classList.remove("focusable"), self.bottomTabs.classList.add("videoOsdTabs-margintop")) : (videoOsdBottomButtons.classList.add("focusable"), videoOsdBottomButtons.classList.remove("hide"), self.bottomTabs.classList.remove("videoOsdTabs-margintop")), isLocalVideo) destroyPlayQueue(self), destroyLyricsRenderer(self);
            else if (self.lyricsRenderer || (self.lyricsRenderer = new _lyrics.default({
                    parent: view.querySelector(".lyricsSection")
                })), !self.playQueue) {
                player = view.querySelector(".osdPlayQueue");
                let osdContentSection = _usersettings.default.osdContentSection() || getDefaultOsdContentSection();
                _layoutmanager.default.tv ? (self.playQueue = new _tvplayqueue.default({
                    parent: player
                }), osdContentSection = "playqueue") : self.playQueue = new _playqueue.default({
                    parent: player
                }), setContentSection(osdContentSection = "lyrics" === osdContentSection ? getDefaultOsdContentSection() : osdContentSection, !1)
            }
            state = self.btnPause;
            isLocalVideo && !_layoutmanager.default.tv ? (mainTransportButtons.classList.add("videoOsd-centerButtons-autolayout"), state.classList.add("videoOsd-btnPause-autolayout"), stopButtons[0].classList.add("btnVideoOsd-stop-center-autolayout")) : (mainTransportButtons.classList.remove("videoOsd-centerButtons-autolayout"), state.classList.remove("videoOsd-btnPause-autolayout"), stopButtons[0].classList.remove("btnVideoOsd-stop-center-autolayout"))
        }

        function getDetailImageItemsSync() {
            let item = currentDisplayItem;
            var items = [];
            return item && (item.SeriesPrimaryImageTag && (item = {
                Id: item.SeriesId,
                Name: item.SeriesName,
                ServerId: item.ServerId,
                ImageTags: {
                    Primary: item.SeriesPrimaryImageTag
                },
                IsFolder: !0,
                PrimaryImageAspectRatio: 2 / 3
            }), items.push(item)), {
                Items: items,
                TotalRecordCount: items.length
            }
        }

        function getDetailImageItems() {
            return Promise.resolve(getDetailImageItemsSync())
        }

        function getDetailImageListOptions(items) {
            let cardClass = "osdRemoteControlImageCard";
            return _layoutmanager.default.tv || (cardClass += " osdRemoteControlImageCard-automargin"), {
                renderer: _cardbuilder.default,
                options: {
                    overlayText: !0,
                    fields: [],
                    action: "none",
                    multiSelect: !1,
                    contextMenu: !_layoutmanager.default.tv,
                    ratingButton: !_layoutmanager.default.tv,
                    playedButton: !1,
                    cardClass: cardClass,
                    cardBoxClass: "osdRemoteControlImageCardBox",
                    cardContentClass: "osdRemoteControlImageCardContent legacyLazyLoadImmediate",
                    defaultIcon: !0,
                    typeIndicator: !1,
                    playedIndicator: !1,
                    syncIndicator: !1,
                    timerIndicator: !1,
                    randomDefaultBackground: !1,
                    staticElement: !0,
                    progress: !1,
                    hoverPlayButton: !1,
                    moreButton: !1,
                    enableUserData: !_layoutmanager.default.tv,
                    shape: "auto"
                },
                virtualScrollLayout: "vertical-grid"
            }
        }

        function onStateChanged(event, state) {
            state.NowPlayingItem && (isEnabled = !0, function(player, state) {
                var playState = (self.lastPlayerState = state).PlayState || {},
                    supportedCommands = (updatePlayPauseState(playState.IsPaused, state.IsInitialRequest), _playbackmanager.default.getSupportedCommands(player));
                currentPlayerSupportedCommands = supportedCommands, updatePlayerVolumeState(0, playState.IsMuted, playState.VolumeLevel, supportedCommands), updatePlayerBrightnessState(player);
                var nowPlayingPositionSlider = self.nowPlayingPositionSlider;
                nowPlayingPositionSlider && !nowPlayingPositionSlider.dragging && (nowPlayingPositionSlider.disabled = !playState.CanSeek);
                for (let i = 0, length = fastForwardButtons.length; i < length; i++) fastForwardButtons[i].disabled = !playState.CanSeek;
                for (let i = 0, length = rewindButtons.length; i < length; i++) rewindButtons[i].disabled = !playState.CanSeek;
                var nowPlayingItem = state.NowPlayingItem || {},
                    displayingLocalVideo = isDisplayingLocalVideo(player, nowPlayingItem.MediaType),
                    focusedElement = (updateTransparency(player, state, nowPlayingItem.MediaType), playbackStartTimeTicks = playState.PlaybackStartTimeTicks, updateTimeDisplay(playState.PositionTicks, nowPlayingItem.RunTimeTicks, playState.PlaybackStartTimeTicks, playState.BufferedRanges || []), updateNowPlayingInfo(0, player, state), document.activeElement);
                state.MediaSource && !state.IsInitialRequest ? displayingLocalVideo || _layoutmanager.default.tv ? (hideButton(btnVideoOsdSettingsTransportButton, focusedElement), self.btnVideoOsdSettingsRight.classList.remove("hide")) : (btnVideoOsdSettingsTransportButton.classList.remove("hide"), hideButton(self.btnVideoOsdSettingsRight, focusedElement)) : (hideButton(self.btnVideoOsdSettingsRight, focusedElement), hideButton(btnVideoOsdSettingsTransportButton, focusedElement));
                var isProgressClear = state.MediaSource && null == state.MediaSource.RunTimeTicks;
                nowPlayingPositionSlider.setIsClear(isProgressClear), !supportedCommands.includes("ToggleFullscreen") || !displayingLocalVideo || player.isLocalPlayer && _layoutmanager.default.tv && _playbackmanager.default.isFullscreen(player) ? hideButton(btnFullscreen, focusedElement) : btnFullscreen.classList.remove("hide");
                state.IsInitialRequest || !supportedCommands.includes("PictureInPicture") || _layoutmanager.default.tv || supportedCommands.includes("AutoPictureInPicture") ? hideButton(view.querySelector(".btnPip"), focusedElement) : view.querySelector(".btnPip").classList.remove("hide");
                updateRepeatModeDisplay(playState.RepeatMode), supportedCommands.includes("SetRepeatMode") && "Video" !== nowPlayingItem.MediaType && _layoutmanager.default.tv ? btnRepeatMode.classList.remove("hide") : hideButton(btnRepeatMode, focusedElement);
                updateFullscreenIcon();
                nowPlayingPositionSlider = state.PlaylistIndex, isProgressClear = state.PlaylistLength;
                updatePlaylistButtons(nowPlayingPositionSlider, isProgressClear, focusedElement);
                displayingLocalVideo = self.playQueue;
                displayingLocalVideo && (supportedCommands = state.PlaylistItemId, displayingLocalVideo.updatePlaylist(player, supportedCommands, nowPlayingPositionSlider, isProgressClear))
            }(this, state))
        }

        function onPlayPauseStateChanged(e) {
            isEnabled && updatePlayPauseState(this.paused())
        }

        function onVolumeChanged(e) {
            isEnabled && updatePlayerVolumeState(0, this.isMuted(), this.getVolume(), currentPlayerSupportedCommands)
        }

        function onBrightnessChanged(e) {
            isEnabled && updatePlayerBrightnessState(this)
        }

        function onPlaybackStart(e, state) {
            console.log("nowplaying event: " + e.type), cancelPositionSliderEditing();
            onStateChanged.call(this, e, state), resetUpNextDialog(), resetRatingText(), showHideSkipIntro(!1), "Video" !== (null == (e = state.NowPlayingItem) ? void 0 : e.MediaType) && self.bottomTabs.selectedIndex(-1)
        }

        function onRepeatModeChange(e) {
            updateRepeatModeDisplay(_playbackmanager.default.getRepeatMode(this))
        }

        function onSubtitleTrackChange() {
            destroySubtitleOffsetOverlay(self)
        }

        function onPlaylistItemAdd(e) {
            var playlistItemId, playlistIndex = _playbackmanager.default.getCurrentPlaylistIndex(this),
                playlistLength = _playbackmanager.default.getCurrentPlaylistLength(this),
                playQueue = (updatePlaylistButtons(playlistIndex, playlistLength, document.activeElement), self.playQueue);
            playQueue && (playlistItemId = _playbackmanager.default.getCurrentPlaylistItemId(this), playQueue.updatePlaylist(this, playlistItemId, playlistIndex, playlistLength))
        }

        function onPlaylistItemMove(e, info) {
            updatePlaylistButtons(_playbackmanager.default.getCurrentPlaylistIndex(this), _playbackmanager.default.getCurrentPlaylistLength(this), document.activeElement);
            var playQueue = self.playQueue;
            playQueue && playQueue.onPlaylistItemMoved(this, e, info)
        }

        function onPlaylistItemRemove(e, info) {
            updatePlaylistButtons(_playbackmanager.default.getCurrentPlaylistIndex(this), _playbackmanager.default.getCurrentPlaylistLength(this), document.activeElement);
            var playQueue = self.playQueue;
            playQueue && playQueue.onPlaylistItemRemoved(this, e, info)
        }

        function resetUpNextDialog() {
            showHideUpNext(comingUpNextDisplayed = !1), btnHideUpNext.classList.remove("hide")
        }

        function onPlaybackStopped(e, state) {
            hideWaiting(), cancelPositionSliderEditing(), currentRuntimeTicks = null, resetRatingText();
            self.currentItem && showComingUpNextIfNeeded(0, self.currentItem, 1, 1, !0, currentCreditsInfo);
            var hideUpNextHasFocus = btnHideUpNext === document.activeElement;
            btnHideUpNext.classList.add("hide"), hideUpNextHasFocus && _focusmanager.default.autoFocus(self.upNextContainer), showHideSkipIntro(!1), console.log("nowplaying event: " + e.type), state.NextMediaType || ((hideUpNextHasFocus = self.playQueue) && hideUpNextHasFocus.onPlaybackStopped(), (e = self.lyricsRenderer) && e.onPlaybackStopped(), self.enableStopOnBack = !1, self.enableBackOnStop && (self.enableBackOnStop = !1, self.exit()))
        }

        function onMediaStreamsChanged(e) {
            var state = _playbackmanager.default.getPlayerState(this);
            onStateChanged.call(this, e, state)
        }

        function releaseCurrentPlayer() {
            cancelPositionSliderEditing(), destroyStats(self), destroySubtitleOffsetOverlay(self), resetUpNextDialog(), resetRatingText(), showHideSkipIntro(!1);
            var player = self.currentPlayer;
            player && (hideWaiting(), _events.default.off(player, "playbackrequest", onPlaybackStart), _events.default.off(player, "playbackstart", onPlaybackStart), _events.default.off(player, "playbackstop", onPlaybackStopped), _events.default.off(player, "volumechange", onVolumeChanged), _events.default.off(player, "brightnesschange", onBrightnessChanged), _events.default.off(player, "pause", onPlayPauseStateChanged), _events.default.off(player, "unpause", onPlayPauseStateChanged), _events.default.off(player, "timeupdate", onTimeUpdate), _events.default.off(player, "waiting", onWaiting), _events.default.off(player, "playing", onPlaying), _events.default.off(player, "fullscreenchange", updateFullscreenIcon), _events.default.off(player, "mediastreamschange", onMediaStreamsChanged), _events.default.off(player, "statechange", onStateChanged), _events.default.off(player, "repeatmodechange", onRepeatModeChange), _events.default.off(player, "subtitletrackchange", onSubtitleTrackChange), _events.default.off(player, "playlistitemadd", onPlaylistItemAdd), _events.default.off(player, "playlistitemmove", onPlaylistItemMove), _events.default.off(player, "playlistitemremove", onPlaylistItemRemove), self.currentPlayer = null)
        }

        function resetRatingText() {
            ratingInfoContainer.classList.add("hide"), ratingTextNeedsUpdate = !0
        }

        function showHideSkipIntro(show) {
            var needToRefocus;
            show ? skipIntroContainer._visible || (skipIntroContainer._visible = !0, skipIntroContainer.classList.remove("hide"), self.currentVisibleMenu) || (_focusmanager.default.focus(btnSkipIntro), enableAutoSkipIntro && btnSkipIntro.click()) : skipIntroContainer._visible && (skipIntroContainer._visible = !1, show = btnSkipIntro === document.activeElement, needToRefocus = !!self.currentVisibleMenu && show, skipIntroContainer.classList.add("hide"), needToRefocus ? focusMainOsdControls(self) : show && btnSkipIntro.blur())
        }

        function showHideUpNext(show, timeRemainingTicks) {
            var upNextContainer = self.upNextContainer;
            show ? upNextContainer._visible || (btnPlayNextFromUpNextProgress.style.transform = "scaleX(0)", upNextContainer._visible = !0, upNextContainer._timeRemainingTicks = timeRemainingTicks, upNextContainer.classList.remove("hide"), self.osdBottomElement.classList.add("videoosd-withupnext"), _focusmanager.default.focus(upNextContainer.querySelector(".btnPlayNextFromUpNext"))) : upNextContainer._visible && (upNextContainer._visible = !1, upNextContainer._timeRemainingTicks = null, show = !!self.currentVisibleMenu && upNextContainer.contains(document.activeElement), upNextContainer.classList.add("hide"), self.osdBottomElement.classList.remove("videoosd-withupnext"), show) && focusMainOsdControls(self)
        }

        function validateSkipIntroFeature(options, incrementAppSettings) {
            return require(["registrationServices"]).then(function(responses) {
                return responses[0].validateFeature("dvr", Object.assign({
                    viewOnly: !0
                }, options)).then(function() {
                    skipIntroValidated = !0, _appsettings.default.introSkipDisplayCount(0)
                }, function(err) {
                    return skipIntroValidated = !1, incrementAppSettings && _appsettings.default.introSkipDisplayCount(_appsettings.default.introSkipDisplayCount() + 1), Promise.reject(err)
                })
            })
        }
        self.updateTransparency = updateTransparency, (itemsContainer = osdPosterContainer).fetchData = getDetailImageItems, itemsContainer.getListOptions = getDetailImageListOptions, _dom.default.addEventListener(btnFullscreen, "click", function() {
            _playbackmanager.default.toggleFullscreen(self.currentPlayer)
        }, {
            passive: !0
        }), view.querySelector(".btnPip").addEventListener("click", function() {
            _playbackmanager.default.togglePictureInPicture(self.currentPlayer)
        }), self.btnVideoOsdSettingsRight.addEventListener("click", onSettingsButtonClick), btnVideoOsdSettingsTransportButton.addEventListener("click", onSettingsButtonClick), self.bindToPlayer = function(player, forceStateChange) {
            player === self.currentPlayer ? forceStateChange && player && onStateChanged.call(player, {
                type: "viewresume"
            }, _playbackmanager.default.getPlayerState(player)) : (releaseCurrentPlayer(), (self.currentPlayer = player) && (onStateChanged.call(player, {
                type: "init"
            }, _playbackmanager.default.getPlayerState(player)), _events.default.on(player, "playbackrequest", onPlaybackStart), _events.default.on(player, "playbackstart", onPlaybackStart), _events.default.on(player, "playbackstop", onPlaybackStopped), _events.default.on(player, "volumechange", onVolumeChanged), _events.default.on(player, "brightnesschange", onBrightnessChanged), _events.default.on(player, "pause", onPlayPauseStateChanged), _events.default.on(player, "unpause", onPlayPauseStateChanged), _events.default.on(player, "timeupdate", onTimeUpdate), _events.default.on(player, "waiting", onWaiting), _events.default.on(player, "playing", onPlaying), _events.default.on(player, "fullscreenchange", updateFullscreenIcon), _events.default.on(player, "mediastreamschange", onMediaStreamsChanged), _events.default.on(player, "statechange", onStateChanged), _events.default.on(player, "repeatmodechange", onRepeatModeChange), _events.default.on(player, "subtitletrackchange", onSubtitleTrackChange), _events.default.on(player, "playlistitemadd", onPlaylistItemAdd), _events.default.on(player, "playlistitemmove", onPlaylistItemMove), _events.default.on(player, "playlistitemremove", onPlaylistItemRemove), resetUpNextDialog(), resetRatingText(), showHideSkipIntro(!1)))
        }, self.releaseCurrentPlayer = releaseCurrentPlayer;
        let IntroEndToleranceTicks = 2e7;

        function onWaiting(e) {
            self.timeWhenWaiting = _playbackmanager.default.currentTime(this), _loading.default.show()
        }

        function hideWaiting() {
            self.timeWhenWaiting = null, _loading.default.hide()
        }

        function onPlaying(e) {
            hideWaiting()
        }

        function onTimeUpdate(e) {
            var now, currentTime, item;
            !isEnabled || (now = Date.now()) - lastUpdateTime < 200 || ((currentTime = _playbackmanager.default.currentTime(this)) !== self.timeWhenWaiting && hideWaiting(), showComingUpNextIfNeeded(0, item = self.currentItem, currentTime, currentRuntimeTicks = _playbackmanager.default.duration(this), !1, currentCreditsInfo), now - lastUpdateTime < 600) || (lastUpdateTime = now, function(currentTime) {
                var introInfo = currentIntroInfo;
                introInfo && enableSkipIntro && currentTime >= introInfo.start && currentTime < introInfo.end - IntroEndToleranceTicks && (!1 !== skipIntroValidated || _appsettings.default.introSkipDisplayCount() < 5) ? (!0 === skipIntroValidated && _appsettings.default.introSkipDisplayCount(0), showHideSkipIntro(!0)) : showHideSkipIntro(!1)
            }(currentTime), function() {
                var item;
                ratingTextNeedsUpdate && (item = currentDisplayItem) && (ratingTextNeedsUpdate = !1, item.OfficialRating && "Trailer" !== item.Type && "Video" === item.MediaType && _usersettings.default.enableRatingInfoOnPlaybackStart() ? (ratingTextElement.innerHTML = _globalize.default.translate("RatedValue", item.OfficialRating), ratingInfoContainer.classList.add("hide"), ratingInfoContainer.offsetWidth, ratingInfoContainer.classList.remove("hide")) : ratingInfoContainer.classList.add("hide"))
            }(), updateTimeDisplay(currentTime, currentRuntimeTicks, _playbackmanager.default.playbackStartTime(this), _playbackmanager.default.getBufferedRanges(this)), function(player, item) {
                if ("TvChannel" === item.Type) {
                    item = item.CurrentProgram;
                    if (item && item.EndDate) try {
                        var state, endDate = _datetime.default.parseISO8601Date(item.EndDate);
                        Date.now() >= endDate.getTime() && (console.log("program info needs to be refreshed"), state = _playbackmanager.default.getPlayerState(player), onStateChanged.call(player, {
                            type: "updatemetadata"
                        }, state))
                    } catch (e) {
                        console.log("Error parsing date: " + item.EndDate)
                    }
                }
            }(this, item))
        }
        let fiftyMinuteTicks = 3e10,
            fortyMinuteTicks = 24e9;

        function showComingUpNextIfNeeded(player, currentItem, currentTimeTicks, runtimeTicks, isStopped, creditsInfo) {
            if ((runtimeTicks && currentTimeTicks || isStopped) && "Episode" === currentItem.Type && self.hasNextTrack) {
                currentItem = runtimeTicks - currentTimeTicks;
                if ((!comingUpNextDisplayed || isStopped) && (creditsInfo = function(runtimeTicks, creditsInfo) {
                        return (creditsInfo = (null == creditsInfo ? void 0 : creditsInfo.start) || 0) && creditsInfo < runtimeTicks ? creditsInfo : runtimeTicks - 1e3 * (runtimeTicks >= fiftyMinuteTicks ? 40 : runtimeTicks >= fortyMinuteTicks ? 35 : 30) * 1e4
                    }(runtimeTicks, creditsInfo), isStopped || creditsInfo <= currentTimeTicks && 3e9 <= runtimeTicks && 2e8 <= currentItem && _usersettings.default.enableNextVideoInfoOverlay()) && (isStopped && btnHideUpNext.classList.add("hide"), showHideUpNext(comingUpNextDisplayed = !0, currentItem)), self.upNextContainer._visible) {
                    creditsInfo = self.upNextContainer._timeRemainingTicks;
                    if (creditsInfo) {
                        let pct = isStopped ? 1 : (creditsInfo - currentItem + 15e6) / creditsInfo;
                        pct *= 100, pct = (pct = Math.min(pct, 100)).toFixed(2), btnPlayNextFromUpNextProgress.style.transform = "scaleX(" + pct + "%)"
                    }
                }
            }
        }

        function updatePlayPauseState(isPaused, isInitialRequest) {
            let title;
            var btnPause = self.btnPause,
                btnPause = (title = isPaused ? (btnPause.querySelector("i").innerHTML = "&#xE037;", _globalize.default.translate("Play")) : (btnPause.querySelector("i").innerHTML = "&#xE034;", _globalize.default.translate("Pause")), btnPause.title = title, btnPause.setAttribute("aria-label", title), btnPause.disabled = !0 === isInitialRequest, self.playQueue);
            btnPause && btnPause.setPausedState(isPaused)
        }

        function hideButton(btn, focusedElement) {
            focusedElement = btn === focusedElement;
            btn.classList.add("hide"), focusedElement && focusMainOsdControls(self)
        }

        function updatePlaylistButtons(playlistIndex, playlistLength, focusedElement) {
            playlistIndex ? btnPreviousTrack.classList.remove("hide") : hideButton(btnPreviousTrack, focusedElement), null != playlistIndex && playlistLength && playlistIndex < playlistLength - 1 ? (self.hasNextTrack = !0, btnNextTrack.classList.remove("hide")) : (self.hasNextTrack = !1, hideButton(btnNextTrack, focusedElement))
        }

        function updateRepeatModeDisplay(repeatMode) {
            var icon = btnRepeatMode.querySelector("i"),
                icon = ("RepeatAll" === repeatMode ? (icon.innerHTML = "&#xE040;", icon.classList.add("toggleButtonIcon-active"), btnRepeatMode.classList.add("toggleButton-active")) : "RepeatOne" === repeatMode ? (icon.innerHTML = "&#xE041;", icon.classList.add("toggleButtonIcon-active"), btnRepeatMode.classList.add("toggleButton-active")) : (icon.innerHTML = "&#xE040;", icon.classList.remove("toggleButtonIcon-active"), btnRepeatMode.classList.remove("toggleButton-active")), self.playQueue);
            icon && icon.updateRepeatModeDisplay(repeatMode)
        }

        function getDisplayPercentByTimeOfDay(programStartDateMs, programRuntimeMs, currentTimeMs) {
            return (currentTimeMs - programStartDateMs) / programRuntimeMs * 100
        }

        function getStep(runtimeTicks) {
            let step = 1e7 * (_layoutmanager.default.tv ? 10 : 1) / runtimeTicks * 100;
            return step = step.toFixed(3), step = Math.max(.01, step), step = Math.min(1, step)
        }

        function updateTimeDisplay(positionTicks, runtimeTicks, playbackStartTimeTicks, bufferedRanges) {
            var nowPlayingPositionSlider = self.nowPlayingPositionSlider;
            if (enableProgressByTimeOfDay) nowPlayingPositionSlider && !nowPlayingPositionSlider.dragging && (programStartDateMs && programEndDateMs ? (currentTimeMs = (playbackStartTimeTicks + (positionTicks || 0)) / 1e4, programRuntimeMs = programEndDateMs - programStartDateMs, nowPlayingSliderRunTimeTicks = 1e4 * programRuntimeMs, nowPlayingPositionSlider.step = getStep(nowPlayingSliderRunTimeTicks), nowPlayingSliderValue = getDisplayPercentByTimeOfDay(programStartDateMs, programRuntimeMs, currentTimeMs), nowPlayingPositionSlider.setValue(nowPlayingSliderValue), bufferedRanges.length ? (currentTimeMs = getDisplayPercentByTimeOfDay(programStartDateMs, programRuntimeMs, (playbackStartTimeTicks + (bufferedRanges[0].start || 0)) / 1e4), programRuntimeMs = getDisplayPercentByTimeOfDay(programStartDateMs, programRuntimeMs, (playbackStartTimeTicks + (bufferedRanges[0].end || 0)) / 1e4), nowPlayingPositionSlider.setBufferedRanges([{
                start: currentTimeMs,
                end: programRuntimeMs
            }])) : nowPlayingPositionSlider.setBufferedRanges([])) : (nowPlayingPositionSlider.step = .01, nowPlayingSliderRunTimeTicks = null, nowPlayingSliderValue = 0, nowPlayingPositionSlider.setValue(0), nowPlayingPositionSlider.setBufferedRanges([])));
            else {
                nowPlayingSliderRunTimeTicks = runtimeTicks, nowPlayingPositionSlider && !nowPlayingPositionSlider.dragging && (playbackStartTimeTicks = currentDisplayItem, !runtimeTicks || currentMediaSource && !currentMediaSource.RunTimeTicks ? (nowPlayingPositionSlider.step = .01, nowPlayingSliderValue = 0, nowPlayingPositionSlider.setValue(0), updateDurationText(runtimeTicks, playbackStartTimeTicks)) : (bufferedRanges = positionTicks / runtimeTicks, bufferedRanges *= 100, nowPlayingPositionSlider.step = getStep(runtimeTicks), nowPlayingSliderValue = bufferedRanges, nowPlayingPositionSlider.setValue(bufferedRanges), updateDurationText(runtimeTicks - positionTicks, playbackStartTimeTicks, !0))), nowPlayingPositionSlider && nowPlayingPositionSlider.setBufferedRanges([]);
                var currentTimeMs = videoOsdPositionText,
                    programRuntimeMs = positionTicks,
                    bufferedRanges = void 0;
                if (null == programRuntimeMs) currentTimeMs.innerHTML = "";
                else if (isNaN(programRuntimeMs)) currentTimeMs.innerHTML = "";
                else {
                    let html = _datetime.default.getDisplayRunningTime(programRuntimeMs);
                    bufferedRanges && (html = "-" + html), currentTimeMs.innerHTML = html
                }
            }
            var bottomTabControllers = self.bottomTabControllers;
            for (let i = 0, length = bottomTabControllers.length; i < length; i++) bottomTabControllers[i] && bottomTabControllers[i].onTimeUpdate(positionTicks, runtimeTicks);
            playbackStartTimeTicks = self.lyricsRenderer;
            playbackStartTimeTicks && playbackStartTimeTicks.onTimeUpdate(positionTicks, currentRuntimeTicks)
        }

        function updateDurationText(durationTicks, displayItem, enableTimeRemaining) {
            var elem = videoOsdDurationText;
            if (null == durationTicks) elem.innerHTML = "";
            else if (isNaN(durationTicks)) elem.innerHTML = "";
            else {
                let html = _datetime.default.getDisplayRunningTime(durationTicks);
                enableTimeRemaining && (html = "-" + html, enableProgressByTimeOfDay || "Video" !== (null == displayItem ? void 0 : displayItem.MediaType) || (html += '<span class="osd-endsat"><span class="osd-endsat-dot">/</span>' + _mediainfo.default.getEndsAtFromPosition(durationTicks, 0, !1).toLowerCase() + "</span>")), elem.innerHTML = html
            }
        }

        function updatePlayerBrightnessState(player) {
            var showSlider = !_layoutmanager.default.tv && currentPlayerSupportedCommands.includes("SetBrightness");
            brightnessSlider && (showSlider ? (brightnessSliderContainer.classList.remove("hide"), brightnessSlider.dragging || brightnessSlider.setValue(_playbackmanager.default.getBrightness(player))) : brightnessSliderContainer.classList.add("hide"))
        }

        function updatePlayerVolumeState(player, isMuted, volumeLevel, supportedCommands) {
            let showMuteButton = !0,
                showVolumeSlider = !0;
            supportedCommands.includes("Mute") || (showMuteButton = !1), supportedCommands.includes("SetVolume") || (showVolumeSlider = !1), isMuted ? (buttonMute.setAttribute("title", _globalize.default.translate("Unmute")), buttonMute.querySelector("i").innerHTML = "&#xE04F;") : (buttonMute.setAttribute("title", _globalize.default.translate("Mute")), buttonMute.querySelector("i").innerHTML = "&#xE050;"), showMuteButton ? buttonMute.classList.remove("hide") : buttonMute.classList.add("hide"), nowPlayingVolumeSlider && (showVolumeSlider ? videoOsdVolumeControls.classList.remove("hide") : videoOsdVolumeControls.classList.add("hide"), nowPlayingVolumeSlider.dragging || nowPlayingVolumeSlider.setValue(volumeLevel))
        }

        function onSettingsButtonClick(e) {
            let btn = this;
            require(["playerSettingsMenu"], function(playerSettingsMenu) {
                var player = self.currentPlayer;
                player && playerSettingsMenu.show({
                    player: player,
                    positionTo: btn,
                    stats: !0,
                    onOption: onSettingsOption,
                    mediaType: self.currentItem.MediaType
                }).then(self.boundShowOsdDefaultParams, self.boundShowOsdDefaultParams)
            })
        }

        function onSettingsOption(selectedOption) {
            "stats" === selectedOption ? toggleStats(self) : "subtitleoffset" === selectedOption && toggleSubtitleOffset()
        }

        function toggleSubtitleOffset() {
            require(["subtitleOffsetOverlay"], function(SubtitleOffsetOverlay) {
                var player = self.currentPlayer;
                player && (self.subtitleOffsetOverlay || (self.subtitleOffsetOverlay = new SubtitleOffsetOverlay({
                    player: player
                })), self.subtitleOffsetOverlay.show())
            })
        }
        let lastPointerEvent = 0;

        function refreshThumbnailsIfNeeded(item, mediaSourceId, apiClient, maxThumbnailWidth) {
            !item.Id || "Audio" === item.MediaType || currentItemThumbnails || currentItemThumbnailsPromise || ! function(itemId, mediaSourceId, apiClient, maxThumbnailWidth) {
                if (currentItemThumbnailsPromise) return currentItemThumbnailsPromise;
                apiClient = apiClient.getThumbnails(itemId, {
                    MediaSourceId: mediaSourceId,
                    Width: maxThumbnailWidth
                }).then(function(result) {
                    return currentItemThumbnails = result, Promise.resolve(result)
                }, function() {
                    currentItemThumbnailsPromise = null
                }), currentItemThumbnailsPromise = apiClient
            }(item.Id, mediaSourceId, apiClient, maxThumbnailWidth)
        }

        function getThumbnailBubbleHtml(apiClient, itemId, mediaSourceId, thumbnailSet, chapters, positionTicks, maxThumbnailWidth) {
            let thumbnail;
            var thumbnails = (thumbnailSet = thumbnailSet || {}).Thumbnails || {},
                bubbleElement = self.nowPlayingPositionSlider.getBubbleElement();
            thumbnails.length ? (bubbleElement.classList.add("chapterThumbImageContainer"), thumbnailSet.AspectRatio && thumbnailSet.AspectRatio < 1.4 ? bubbleElement.classList.add("chapterThumbImageContainer-fourthree") : bubbleElement.classList.remove("chapterThumbImageContainer-fourthree"), bubbleElement.classList.remove("chapterThumbImageContainer-noimg")) : (bubbleElement.classList.remove("chapterThumbImageContainer", "chapterThumbImageContainer-fourthree"), bubbleElement.classList.add("chapterThumbImageContainer-noimg")), _layoutmanager.default.tv ? bubbleElement.classList.add("chapterThumbImageContainer-tv") : bubbleElement.classList.remove("chapterThumbImageContainer-tv");
            for (let i = 0, length = thumbnails.length; i < length; i++) {
                var currentThumbnail = thumbnails[i];
                if (positionTicks >= currentThumbnail.PositionTicks) thumbnail = currentThumbnail;
                else if (thumbnail) break
            }
            let chapter;
            for (let i = 0, length = chapters.length; i < length; i++) {
                var currentChapter = chapters[i];
                if (positionTicks >= currentChapter.StartPositionTicks) chapter = currentChapter;
                else if (chapter) break
            }
            chapter = chapter || {
                Name: "&nbsp;"
            };
            thumbnailSet = thumbnail ? function(itemId, thumbnail, maxWidth, apiClient) {
                return thumbnail.ImageTag ? apiClient.getImageUrl(itemId, {
                    maxWidth: maxWidth,
                    tag: thumbnail.ImageTag,
                    type: "Thumbnail",
                    PositionTicks: thumbnail.PositionTicks
                }) : null
            }(itemId, thumbnail, maxThumbnailWidth, apiClient) : null;
            let html = "",
                textContainerClass = "chapterThumbTextContainer";
            return thumbnailSet || (textContainerClass += " chapterThumbTextContainer-noimg"), self.nowPlayingPositionSlider.getBubbleElement().style.backgroundImage = thumbnailSet ? "url('" + thumbnailSet + "')" : null, html = (html = (html = (html = (html = html + ('<div class="' + textContainerClass + '">') + '<div class="chapterThumbText">') + (chapter ? _dom.default.htmlEncode(chapter.Name) : "&nbsp;")) + "</div>" + (thumbnailSet ? '<div class="chapterThumbText">' : '<div class="chapterThumbText secondaryText">')) + _datetime.default.getDisplayRunningTime(positionTicks)) + "</div>" + "</div>"
        }

        function onStop() {
            _playbackmanager.default.stop(self.currentPlayer)
        }
        //0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
    var my_touches_type = null;
    var my_touches_start = null;
    var my_touches_value = 0;
    var my_touches_nowvalue = 0;
    var my_touches_rate = null;
    var my_touches_time = null;
    function my_touches_func(e, v, t, x, s) {
      v = v > 0 ? v - 20 : v + 20;
      let step = (Math.abs(v) / (s ? x * 5 : x * 0.5)) * 100;
      step = v > 0 ? step : -step;
      v = s ? t + step : t - step;
      step = v > 100 ? 100 : v < 0 ? 0 : v;
      if (v > 100 || v < 0) {
        my_touches_start = e;
        my_touches_nowvalue = step;
      }
      return step;
    }
    _dom.default.addEventListener(view, "touchstart", function (e) {
      if (shouldOsdBeShown(self) && !self.currentVisibleMenu && self.currentLockState === 0) {
        my_touches_type = null;
        my_touches_start = e.touches[0];
        my_touches_value = 0;
        my_touches_time = setTimeout(() => {
          if (my_touches_type === null) {
            my_touches_rate = _playbackmanager.default.getPlaybackRate(
              self.currentPlayer
            );
            _playbackmanager.default.setPlaybackRate(
              my_touches_rate * 2,
              self.currentPlayer
            );
          }
        }, 1500);
      } else {
        my_touches_start = null;
        my_touches_rate = null;
      }
    }),
      _dom.default.addEventListener(view, "touchmove", function (e) {
        if (my_touches_start != null && my_touches_rate === null) {
          let x = e.touches[0].pageX - my_touches_start.pageX;
          let y = e.touches[0].pageY - my_touches_start.pageY;
          if (my_touches_type === null && Math.abs(x) > 20 || my_touches_type === "play") {
            my_touches_type = "play";
            my_touches_value = my_touches_func(e.touches[0], x, nowPlayingSliderValue, screen.width, true);
            self.nowPlayingPositionSlider.beginEditing(my_touches_value);
          }
        }
      }),
      _dom.default.addEventListener(view, "touchend", function (e) {
        if (my_touches_start && (my_touches_value !== 0 || my_touches_type != null)) {
          if (my_touches_type === "play") {
            nowPlayingSliderValue = my_touches_value;
            self.nowPlayingPositionSlider.setValue(my_touches_value);
            clearEndEditTimeoutForPositionSlider();
            endEditTimeoutForPositionSlider = endEditsForPositionSlider();
          }
          my_touches_start = null;
          my_touches_type = null;
          self.hideOsd();
        }
        if (my_touches_time != null) {
          clearTimeout(my_touches_time);
          my_touches_time = null;
        }
        if (my_touches_rate != null) {
          _playbackmanager.default.setPlaybackRate(
            my_touches_rate,
            self.currentPlayer
          );
          my_touches_rate = null;
        }
      }),
//0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
        _dom.default.addEventListener(view, window.PointerEvent && !_dom.default.supportsPointerTypeInClickEvent() ? "pointerup" : "click", function(e) {
            let pointerType = e.pointerType;
            var now, isEnoughTimeSinceLastTap;
            pointerType = pointerType || (supportsTouchEvent ? "touch" : "mouse"), "touch" === (lastPointerUpType = pointerType) ? e.target.closest("BUTTON,INPUT,.videoosd-tabcontainers") ? self.showOsd() : !(isEnoughTimeSinceLastTap = 300 < (now = Date.now()) - lastPointerEvent) && "click" !== e.type || (lastPointerEvent = now, self.currentVisibleMenu ? setTimeout(self.boundHideOsd, 10) : self.currentVisibleMenu || isEnoughTimeSinceLastTap && setTimeout(self.boundShowOsdDefaultParams, 100)) : onOsdClick(e, self, null, !0)
        }, {
            passive: !0
        }), _dom.default.addEventListener(view, "dblclick", function(e) {
            e.target.closest("BUTTON") || "mouse" === lastPointerUpType && _playbackmanager.default.toggleFullscreen(self.currentPlayer)
        }, {
            passive: !0
        }), _dom.default.addEventListener(buttonMute, "click", function() {
            _playbackmanager.default.toggleMute(self.currentPlayer)
        }, {
            passive: !0
        }), _dom.default.addEventListener(brightnessSlider, "change", function() {
            _playbackmanager.default.setBrightness(parseFloat(this.value), self.currentPlayer), self.showOsd()
        }, {
            passive: !0
        }), _dom.default.addEventListener(brightnessSlider, "input", function() {
            _playbackmanager.default.setBrightness(parseFloat(this.value), self.currentPlayer), self.showOsd()
        }, {
            passive: !0
        }), _dom.default.addEventListener(nowPlayingVolumeSlider, "change", function() {
            _playbackmanager.default.setVolume(parseFloat(this.value), self.currentPlayer), self.showOsd()
        }, {
            passive: !0
        }), _dom.default.addEventListener(self.nowPlayingPositionSlider, "change", function() {
            var newPercent, seekAirTimeTicks, player = self.currentPlayer;
            player && (newPercent = parseFloat(this.value), enableProgressByTimeOfDay ? (seekAirTimeTicks = (programEndDateMs - programStartDateMs) * (newPercent / 100) * 1e4, seekAirTimeTicks = (seekAirTimeTicks += 1e4 * programStartDateMs) - playbackStartTimeTicks, _playbackmanager.default.seek(seekAirTimeTicks, player)) : _playbackmanager.default.seekPercent(newPercent, player))
        }, {
            passive: !0
        }), self.nowPlayingPositionSlider.getBubbleHtml = function(value) {
            if (self.showOsd(), enableProgressByTimeOfDay) return programStartDateMs && programEndDateMs ? (ms = (ms = (ms = programEndDateMs - programStartDateMs) / 100 * value) + programStartDateMs, '<h3 class="sliderBubbleText">' + getDisplayTimeWithoutAmPm(new Date(parseInt(ms)), !0) + "</h3>") : "--:--";
            if (!currentRuntimeTicks) return "--:--";
            var ms = currentRuntimeTicks,
                value = (ms = ms / 100 * value, self.currentItem);
            if (value) {
                var apiClient = _connectionmanager.default.getApiClient(value.ServerId),
                    thumbnails = (refreshThumbnailsIfNeeded(value, "", apiClient, 400), currentItemThumbnails),
                    chapters = currentDisplayChapters || [];
                if (chapters.length) {
                    apiClient = getThumbnailBubbleHtml(apiClient, value.Id, 0, thumbnails, chapters, ms, 400);
                    if (apiClient) return apiClient
                }
            }
            return '<h2 class="sliderBubbleText">' + _datetime.default.getDisplayRunningTime(ms) + "</h2>"
        }, _dom.default.addEventListener(self.osdBottomElement, transitionEndEventName, function(e) {
            var elem = e.currentTarget;
            elem === e.target && elem.classList.contains("videoOsdBottom-hidden") && (elem.classList.add("hide"), headerElement.classList.add("hide"), self.bottomTabs.selectedIndex(-1), onTabTransitionEnd.call(tabContainersElem, {
                target: tabContainersElem,
                currentTarget: tabContainersElem
            }), 2 === self.currentLockState && self.setLockState(1), view.dispatchEvent(new CustomEvent("video-osd-hide", {
                bubbles: !0
            })))
        }, {
            passive: !0
        }), _dom.default.addEventListener(btnPreviousTrack, "click", function() {
            _playbackmanager.default.previousTrack(self.currentPlayer)
        }, {
            passive: !0
        });
        for (let i = 0, length = stopButtons.length; i < length; i++) stopButtons[i].addEventListener("click", onStop);

        function onNextTrackClick() {
            _playbackmanager.default.nextTrack(self.currentPlayer)
        }

        function onRewindButtonClick() {
            rewind(self, !0)
        }
        _dom.default.addEventListener(self.btnPause, "click", function() {
            _playbackmanager.default.playPause(self.currentPlayer)
        }, {
            passive: !0
        }), _dom.default.addEventListener(btnNextTrack, "click", onNextTrackClick, {
            passive: !0
        });
        for (let i = 0, length = rewindButtons.length; i < length; i++) _dom.default.addEventListener(rewindButtons[i], "click", onRewindButtonClick, {
            passive: !0
        });

        function onFastForwardButtonClick() {
            fastForward(self, !0)
        }
        for (let i = 0, length = fastForwardButtons.length; i < length; i++) _dom.default.addEventListener(fastForwardButtons[i], "click", onFastForwardButtonClick, {
            passive: !0
        });

        function onMoreClick() {
            showMoreMenu(self.currentItem, this)
        }

        function onCloseRequestedFromTab() {
            self.bottomTabs.selectedIndex(-1)
        }

        function loadBottomTabController(index, forceRefresh) {
            let tabResumeOptions = {
                refresh: forceRefresh,
                item: self.currentItem,
                displayItem: currentDisplayItem,
                mediaSource: currentMediaSource,
                enableProgressByTimeOfDay: enableProgressByTimeOfDay,
                currentPlayer: self.currentPlayer
            };
            const bottomTabControllers = self.bottomTabControllers;
            if (bottomTabControllers[index]) return bottomTabControllers[index].onResume(tabResumeOptions);
            require([
                ["videoosd_infotab", "videoosd_chapterstab", "videoosd_peopletab", "videoosd_onnowtab", "videoosd_guidetab"][index]
            ]).then(function(responses) {
                responses = new responses[0](tabContainers[index]);
                return bottomTabControllers[index] = responses, tabResumeOptions.refresh = !0, _events.default.on(responses, "closerequested", onCloseRequestedFromTab), responses.onResume(tabResumeOptions)
            })
        }

        function onTabTransitionEnd(e) {
            var elem = e.currentTarget;
            elem === e.target && elem.classList.contains("videoosd-tabcontainers-hidden") && (elem.classList.add("hide"), self.osdBottomElement.classList.remove("videoosd-bottom-with-opentab"), (e = elem.querySelector(".videoosd-activetab")) && e.classList.remove("videoosd-activetab"), focusMainOsdControls(self))
        }

        function setContentSection(sectionName, saveToUserSettings) {
            currentOsdContentSectionName = sectionName;
            var sections = view.querySelectorAll(".osdContentSection");
            for (let i = 0, length = sections.length; i < length; i++) {
                var section = sections[i];
                section.getAttribute("data-contentsection") === sectionName ? section.classList.remove("hide") : section.classList.add("hide")
            }
            var buttons = view.querySelectorAll(".osdContentSectionToggleButton");
            for (let i = 0, length = buttons.length; i < length; i++) {
                var button = buttons[i],
                    icon = button.querySelector("i");
                button.getAttribute("data-contentsection") === sectionName ? (button.classList.add("toggleButton-active"), icon.classList.add("toggleButtonIcon-active")) : (button.classList.remove("toggleButton-active"), icon.classList.remove("toggleButtonIcon-active"))
            }
            var playQueue = self.playQueue,
                playQueue = ("playqueue" === sectionName ? playQueue && playQueue.resume({}) : playQueue && playQueue.pause(), self.lyricsRenderer),
                playQueue = ("lyrics" === sectionName ? playQueue && playQueue.resume({}) : playQueue && playQueue.pause(), self.osdBottomElement);
            _layoutmanager.default.tv ? (sectionName && "playqueue" !== sectionName && "art" !== sectionName ? playQueue.classList.add("videoOsdBottom-split") : playQueue.classList.remove("videoOsdBottom-split"), sectionName && "lyrics" !== sectionName && "art" !== sectionName ? playQueue.classList.remove("videoOsdBottom-art") : playQueue.classList.add("videoOsdBottom-art")) : sectionName && "art" !== sectionName ? (playQueue.classList.add("videoOsdBottom-split"), playQueue.classList.remove("videoOsdBottom-art")) : (playQueue.classList.remove("videoOsdBottom-split"), playQueue.classList.add("videoOsdBottom-art")), !1 !== saveToUserSettings && _usersettings.default.osdContentSection(sectionName)
        }

        function onContentSectionToggleButtonClick(e) {
            this.classList.contains("toggleButton-active") ? setContentSection("art") : setContentSection(this.getAttribute("data-contentsection"))
        }

        function onSkipIntroClickInternal() {
            var info = currentIntroInfo,
                player = self.currentPlayer;
            info && player && (_playbackmanager.default.seek(info.end, player), showHideSkipIntro(!1), self.hideOsd())
        }

        function onLockClick() {
            let lockState = self.currentLockState;
            switch (lockState) {
                case 0:
                case 1:
                    lockState++;
                    break;
                default:
                    lockState = 0
            }
            self.setLockState(lockState)
        }
        _dom.default.addEventListener(btnRepeatMode, "click", function() {
            var player;
            (player = self.currentPlayer) && _playbackmanager.default.toggleRepeatMode(player)
        }, {
            passive: !0
        }), _dom.default.addEventListener(btnOsdMoreBottom, "click", onMoreClick, {
            passive: !0
        }), _dom.default.addEventListener(btnOsdMoreTitle, "click", onMoreClick, {
            passive: !0
        }), _dom.default.addEventListener(btnAudio, "click", function() {
            let player = self.currentPlayer;
            if (player) {
                var audioTracks = _playbackmanager.default.audioTracks(player);
                let currentIndex = _playbackmanager.default.getAudioStreamIndex(player);
                audioTracks = audioTracks.map(function(stream) {
                    var opt = {
                        name: stream.DisplayTitle,
                        secondaryText: stream.Title && !(stream.DisplayTitle || "").toLowerCase().includes((stream.Title || "").toLowerCase()) ? stream.Title : null,
                        id: stream.Index
                    };
                    return stream.Index === currentIndex && (opt.selected = !0), opt
                });
                self.showOsd(), showActionSheet({
                    items: audioTracks,
                    title: _globalize.default.translate("Audio"),
                    positionTo: this,
                    positionY: "above",
                    transformOrigin: "center bottom",
                    hasItemSelectionState: !0,
                    autoTvLayout: !1
                }).then(function(id) {
                    self.showOsd();
                    id = parseInt(id);
                    id !== currentIndex && _playbackmanager.default.setAudioStreamIndex(id, player)
                }, self.boundShowOsdDefaultParams)
            }
        }, {
            passive: !0
        }), _dom.default.addEventListener(btnSubtitles, "click", function() {
            let player = self.currentPlayer;
            var streams = _playbackmanager.default.subtitleTracks(player);
            let currentIndex = _playbackmanager.default.getSubtitleStreamIndex(player),
                menuItems = (null == currentIndex && (currentIndex = -1), streams.unshift({
                    Index: -1,
                    DisplayTitle: _globalize.default.translate("Off")
                }), streams.map(function(stream) {
                    var opt = {
                        name: stream.DisplayTitle,
                        secondaryText: stream.Title && !(stream.DisplayTitle || "").toLowerCase().includes((stream.Title || "").toLowerCase()) ? stream.Title : null,
                        id: stream.Index
                    };
                    return stream.Index === currentIndex && (opt.selected = !0), opt
                })),
                positionTo = this,
                apiClient = _connectionmanager.default.getApiClient(self.currentItem);
            apiClient.getCurrentUser().then(function(user) {
                supportsSubtitleDownloading(apiClient) && _itemmanager.default.canDownloadSubtitles(self.currentItem, user) && menuItems.push({
                    name: _globalize.default.translate("SearchForSubtitles"),
                    id: "search",
                    asideIcon: "&#xE8B6;"
                }), _playbackmanager.default.getSupportedCommands(player).includes("SetSubtitleOffset") && (user = _playbackmanager.default.getSubtitleStream(player)) && ("External" === user.DeliveryMethod || "Hls" === user.DeliveryMethod) && menuItems.unshift({
                    name: _globalize.default.translate("HeaderSubtitleOffset"),
                    id: "subtitleoffset",
                    secondaryText: _playbackmanager.default.getSubtitleOffset(player) + " ms",
                    asideIcon: "&#xe01b;",
                    dividerAfter: 0 < menuItems.length
                }), self.showOsd(), showActionSheet({
                    title: _globalize.default.translate("Subtitles"),
                    items: menuItems,
                    positionTo: positionTo,
                    positionY: "above",
                    transformOrigin: "center bottom",
                    hasItemSelectionState: !0,
                    hasItemAsideIcon: !0,
                    autoTvLayout: !1
                }).then(function(id) {
                    var item, mediaSource;
                    self.showOsd(), "search" === id ? (item = self.currentItem, mediaSource = currentMediaSource, require(["registrationServices", "subtitleEditor"]).then(function(responses) {
                        return responses[0].validateFeature("sync").then(function() {
                            return responses[1].show({
                                item: item,
                                mediaSource: mediaSource,
                                showCurrentSubtitles: !1,
                                autoSearch: !0,
                                closeOnDownload: !0
                            }).then(function(result) {
                                self.showOsd(), _playbackmanager.default.setSubtitleStreamIndex(result.NewIndex, self.currentPlayer, !0)
                            }, self.boundShowOsdDefaultParams)
                        })
                    })) : "subtitleoffset" === id ? toggleSubtitleOffset() : (id = parseInt(id)) !== currentIndex && _playbackmanager.default.setSubtitleStreamIndex(id, player)
                }, self.boundShowOsdDefaultParams)
            })
        }, {
            passive: !0
        }), videoOsdBottomContentbuttons.getFocusableElements = videoOsdBottomButtons.getFocusableElements = function(parent, activeElement, direction, options) {
            if (!_layoutmanager.default.tv) return null;
            switch (direction) {
                case 0:
                case 1:
                    return Array.prototype.slice.call(videoOsdBottomButtons.querySelectorAll("button"), 0).concat(Array.prototype.slice.call(videoOsdBottomContentbuttons.querySelectorAll("button"), 0));
                default:
                    return null
            }
        }, self.bottomTabs.addEventListener("beforetabchange", function(e) {
            var previousPanel, newPanel = tabContainers[e.detail.selectedTabIndex];
            null != e.detail.previousIndex && ((previousPanel = tabContainers[e.detail.previousIndex]) && newPanel && previousPanel.classList.remove("videoosd-activetab"), previousPanel = self.bottomTabControllers[e.detail.previousIndex]) && previousPanel.onPause(), newPanel ? (loadBottomTabController(e.detail.selectedTabIndex), newPanel.classList.add("videoosd-activetab"), tabContainersElem.classList.remove("hide"), tabContainersElem.offsetWidth, tabContainersElem.classList.remove("videoosd-tabcontainers-hidden"), self.osdBottomElement.classList.add("videoosd-bottom-with-opentab"), btnCloseTabContent.classList.remove("hide")) : (tabContainersElem.classList.add("videoosd-tabcontainers-hidden"), btnCloseTabContent.classList.add("hide"))
        }), btnCloseTabContent.addEventListener("click", function() {
            self.bottomTabs.selectedIndex(-1)
        }), _dom.default.addEventListener(tabContainersElem, transitionEndEventName, onTabTransitionEnd, {
            passive: !0
        }), _inputmanager.default.on(self.bottomTabs, function(e) {
            switch (e.detail.command) {
                case "up":
                    -1 !== self.bottomTabs.selectedIndex() && (self.bottomTabs.selectedIndex(-1), e.preventDefault(), e.stopPropagation(), self.showOsd());
                    break;
                case "down":
                    var btn; - 1 === self.bottomTabs.selectedIndex() && ((btn = e.target.closest(".videoosd-tab-button")) ? self.bottomTabs.selectedIndex(parseInt(btn.getAttribute("data-index"))) : self.bottomTabs.selectedIndex(-1))
            }
        });
        var lockButtons = view.querySelectorAll(".videoOsd-btnToggleLock");
        for (let i = 0, length = lockButtons.length; i < length; i++) _dom.default.addEventListener(lockButtons[i], "click", onLockClick, {
            passive: !0
        });
        if (_dom.default.addEventListener(btnHideUpNext, "click", function() {
                showHideUpNext(!1)
            }, {
                passive: !0
            }), _dom.default.addEventListener(view.querySelector(".btnPlayNextFromUpNext"), "click", onNextTrackClick, {
                passive: !0
            }), _dom.default.addEventListener(btnSkipIntro, "click", function() {
                if (!skipIntroValidated) return validateSkipIntroFeature().then(onSkipIntroClickInternal);
                onSkipIntroClickInternal()
            }, {
                passive: !0
            }), _dom.default.addEventListener(view.querySelector(".btnPlayQueue"), "click", onContentSectionToggleButtonClick, {
                passive: !0
            }), _dom.default.addEventListener(btnLyrics, "click", onContentSectionToggleButtonClick, {
                passive: !0
            }), _dom.default.allowBackdropFilter()) {
            var toggleButtonIcons = view.querySelectorAll(".toggleButtonIcon");
            for (let i = 0, length = toggleButtonIcons.length; i < length; i++) toggleButtonIcons[i].classList.add("toggleButtonIcon-backdropfilter")
        }
        _inputmanager.default.on(self.nowPlayingPositionSlider, function(e) {
            let stepUpCommand, stepDownCommand;
            switch (stepDownCommand = "rtl" === document.dir ? (stepUpCommand = "left", "right") : (stepUpCommand = "right", "left"), e.detail.command) {
                case stepDownCommand:
                case "rewind":
                    e.preventDefault(), nowPlayingSliderValue = e.detail.repeat ? Math.min(Math.max(nowPlayingSliderValue - parseFloat(this.step), this.min), this.max) : Math.min(Math.max(nowPlayingSliderValue - convertMsToNowPlayingSliderStep(_usersettings.default.skipBackLength()), this.min), this.max), this.beginEditing(nowPlayingSliderValue), startEndEditTimeoutForPositionSlider();
                    break;
                case stepUpCommand:
                case "fastforward":
                    e.preventDefault(), nowPlayingSliderValue = e.detail.repeat ? Math.min(Math.max(nowPlayingSliderValue + parseFloat(this.step), this.min), this.max) : Math.min(Math.max(nowPlayingSliderValue + convertMsToNowPlayingSliderStep(_usersettings.default.skipForwardLength()), this.min), this.max), this.beginEditing(nowPlayingSliderValue), startEndEditTimeoutForPositionSlider();
                    break;
                case "pageup":
                    e.preventDefault(), _playbackmanager.default.nextChapter(self.currentPlayer);
                    break;
                case "pagedown":
                    e.preventDefault(), _playbackmanager.default.previousChapter(self.currentPlayer);
                    break;
                case "back":
                    cancelPositionSliderEditing();
                    break;
                case "play":
                case "playpause":
                    self.nowPlayingPositionSlider.dragging && (e.preventDefault(), e.stopPropagation(), self.nowPlayingPositionSlider.endEditing(!0, nowPlayingSliderValue));
                    break;
                case "select":
                    self.nowPlayingPositionSlider.dragging ? (e.preventDefault(), e.stopPropagation(), self.nowPlayingPositionSlider.endEditing(!0, nowPlayingSliderValue)) : _playbackmanager.default.playPause(self.currentPlayer)
            }
        }), self.nowPlayingPositionSlider.addEventListener("keydown", function(e) {
            var key = _keyboard.default.normalizeKeyFromEvent(e);
            "Enter" !== key && " " !== key || this.dragging && (e.preventDefault(), e.stopPropagation(), this.endEditing(!0, nowPlayingSliderValue))
        }), self.nowPlayingPositionSlider.addEventListener("blur", function(e) {
            cancelPositionSliderEditing()
        });
        var sections = view.querySelectorAll(".osdContentSection");
        for (let i = 0, length = sections.length; i < length; i++) {
            var section = sections[i];
            _layoutmanager.default.tv && "lyrics" !== section.getAttribute("data-contentsection") || section.classList.add("osdContentSection-split"), _layoutmanager.default.tv && "lyrics" === section.getAttribute("data-contentsection") && section.classList.add("osdContentSection-tv-split")
        }
        _shortcuts.default.on(this.videoOsdText), this.boundHideOsd = this.hideOsd.bind(this), this.boundShowOsdDefaultParams = function() {
            this.showOsd()
        }.bind(this), this.boundOnOsdHideTimeout = function() {
            _focusmanager.default.hasExclusiveFocusScope() || 0 <= this.bottomTabs.selectedIndex() ? startOsdHideTimer(this) : this.mouseOverButton || this.hideOsd()
        }.bind(this)
    }
    Object.assign(VideoOsd.prototype, _baseview.default.prototype), VideoOsd.prototype.enableWindowInputCommands = function() {
        return !0
    }, VideoOsd.prototype.onWindowInputCommand = function(e) {
        var _instance$currentPlay2, mediaType;
        switch (e.detail.command) {
            case "back":
                var upNextContainer = e.target.closest(".upNextContainer");
                return upNextContainer ? (e.preventDefault(), void upNextContainer.querySelector(".btnHideUpNext").click()) : void(!_layoutmanager.default.tv || _focusmanager.default.hasExclusiveFocusScope() || (upNextContainer = null == (upNextContainer = e.detail.originalEvent) ? void 0 : upNextContainer.target) && headerElement.contains(upNextContainer) || (isDisplayingLocalVideo(this.currentPlayer) ? this.currentVisibleMenu && !this.upNextContainer._visible && (e.preventDefault(), this.hideOsd()) : !this.currentVisibleMenu && (upNextContainer = this.currentPlayer) && upNextContainer.isLocalPlayer && (mediaType || _playbackmanager.default.isPlaying(upNextContainer)) && (e.preventDefault(), this.showOsd())));
            case "left":
                return e.target.closest(".skipIntroContainer,.upNextContainer") ? void 0 : void("rtl" === document.dir ? onFastForwardInputCommand : onRewindInputCommand)(e, this);
            case "rewind":
                return void onRewindInputCommand(e, this);
            case "right":
                return e.target.closest(".skipIntroContainer,.upNextContainer") ? void 0 : void("rtl" === document.dir ? onRewindInputCommand : onFastForwardInputCommand)(e, this);
            case "fastforward":
                return void onFastForwardInputCommand(e, this);
            case "pageup":
                return void _playbackmanager.default.nextChapter(this.currentPlayer);
            case "pagedown":
                return void _playbackmanager.default.previousChapter(this.currentPlayer);
            case "playpause":
                e.preventDefault(), e.stopPropagation();
                var isPaused = null == (upNextContainer = this.currentPlayer) ? void 0 : upNextContainer.paused();
                return _playbackmanager.default.playPause(this.currentPlayer), void((this.currentVisibleMenu || shouldOsdBeShown(this) && !isPaused) && this.showOsd());
            case "play": {
                e.preventDefault(), e.stopPropagation();
                let isPaused = null == (_instance$currentPlay2 = this.currentPlayer) ? void 0 : _instance$currentPlay2.paused();
                return _playbackmanager.default.unpause(this.currentPlayer), void((this.currentVisibleMenu || shouldOsdBeShown(this) && !isPaused) && this.showOsd())
            }
            case "select":
                return void(onOsdClick(e, this, null, shouldOsdBeShown(this)) && e.preventDefault());
            case "up":
            case "down":
                return void(shouldOsdBeShown(this) && this.showOsd());
            case "menu":
            case "pause":
            case "nowplaying":
                return void(shouldOsdBeShown(this) && this.showOsd());
            case "record":
                return shouldOsdBeShown(this) && this.showOsd(), void
                function(instance) {
                    (instance = instance.btnRecord).classList.contains("hide") || instance.click()
                }(this);
            case "togglestats":
                return void toggleStats(this);
            case "movies":
            case "music":
            case "tv":
            case "settings":
            case "search":
            case "favorites":
            case "recordedtv":
                return void e.preventDefault();
            case "info":
                return setBottomTabIndex(this, 0), void e.preventDefault();
            case "livetv":
                return this.bottomTabButtons[3].classList.contains("hide") || setBottomTabIndex(this, 3), void e.preventDefault();
            case "guide":
                return this.bottomTabButtons[4].classList.contains("hide") || setBottomTabIndex(this, 4), void e.preventDefault()
        }
        _baseview.default.prototype.onWindowInputCommand.apply(this, arguments)
    }, VideoOsd.prototype.setLockState = function(lockState) {
        ((this.currentLockState = lockState) ? (headerElement.classList.add("videoOsdHeader-locked"), this.osdBottomElement.classList.add("videoosd-bottom-locked"), this.view.querySelector(".videoOsdUnlockControls").classList.remove("hide"), 1 === lockState ? (this.view.querySelector(".videoOsd-btnUnlock1").classList.remove("hide"), this.view.querySelector(".videoOsd-btnUnlock2").classList.add("hide")) : (this.view.querySelector(".videoOsd-btnUnlock1").classList.add("hide"), this.view.querySelector(".videoOsd-btnUnlock2").classList.remove("hide")), lockOrientation) : (headerElement.classList.remove("videoOsdHeader-locked"), this.osdBottomElement.classList.remove("videoosd-bottom-locked"), this.view.querySelector(".videoOsdUnlockControls").classList.add("hide"), this.view.querySelector(".videoOsd-btnUnlock1").classList.add("hide"), this.view.querySelector(".videoOsd-btnUnlock2").classList.add("hide"), unlockOrientation))()
    }, VideoOsd.prototype.showOsd = function(timeoutMs, elementToFocus) {
        this.paused || (headerElement.classList.remove("hide"), headerElement.offsetWidth, headerElement.classList.remove("videoOsdHeader-hidden"), function(instance, elementToFocus) {
            var elem;
            instance.currentVisibleMenu || (elem = instance.osdBottomElement, instance.currentVisibleMenu = "osd", elem.classList.remove("hide"), elem.offsetWidth, elem.classList.remove("videoOsdBottom-hidden"), _focusmanager.default.hasExclusiveFocusScope() || (elementToFocus ? _focusmanager.default.focus(elementToFocus) : focusMainOsdControls(instance)), console.log("showMainOsdControls activeElement: " + document.activeElement.className), instance.view.dispatchEvent(new CustomEvent("video-osd-show", {
                bubbles: !0
            })))
        }(this, elementToFocus), startOsdHideTimer(this, timeoutMs))
    }, VideoOsd.prototype.hideOsd = function() {
        var instance, elem;
        isDisplayingLocalVideo(this.currentPlayer) && (headerElement.classList.add("videoOsdHeader-hidden"), (instance = this).currentVisibleMenu && ((elem = instance.osdBottomElement).offsetWidth, elem.classList.add("videoOsdBottom-hidden"), instance.currentVisibleMenu = null), elem = this.lyricsRenderer) && !elem.paused && _layoutmanager.default.tv && elem.focus()
    }, VideoOsd.prototype.exit = function() {
        _approuter.default.back()
    }, VideoOsd.prototype.onResume = function(options) {
        _baseview.default.prototype.onResume.apply(this, arguments), _layoutmanager.default.tv ? headerElement.classList.add("videoOsdHeader") : headerElement.classList.add("videoOsdHeader", "videoOsd-customFont-x2");
        let boundOnPlayerChange = this.boundOnPlayerChange;
        boundOnPlayerChange = boundOnPlayerChange || (this.boundOnPlayerChange = function(e, player) {
            this.bindToPlayer(player), this.bottomTabs.selectedIndex(-1)
        }.bind(this)), _events.default.on(_playbackmanager.default, "playerchange", boundOnPlayerChange), this.bindToPlayer(_playbackmanager.default.getCurrentPlayer(), !0);
        var player = this.currentPlayer,
            player = (player && !options.refresh && this.updateTransparency(player, this.lastPlayerState || {}, null == (player = this.currentItem) ? void 0 : player.MediaType), this.view);
        let boundPointerMove = this.boundPointerMove,
            boundPointerEnter = (boundPointerMove = boundPointerMove || (this.boundPointerMove = function(e) {
                var obj, pointerType = e.pointerType;
                "touch" === pointerType || !pointerType && supportsTouchEvent || (pointerType = e.screenX || 0, e = e.screenY || 0, (obj = this.lastPointerMoveData) ? Math.abs(pointerType - obj.x) < 10 && Math.abs(e - obj.y) < 10 || (obj.x = pointerType, obj.y = e, this.showOsd()) : (this.lastPointerMoveData = {
                    x: pointerType,
                    y: e
                }, this.showOsd()))
            }.bind(this)), _dom.default.addEventListener(document, window.PointerEvent ? "pointermove" : "mousemove", boundPointerMove, {
                passive: !0
            }), this.boundPointerEnter),
            boundPointerLeave = (boundPointerEnter = boundPointerEnter || (this.boundPointerEnter = function(e) {
                var pointerType = e.pointerType;
                "touch" === pointerType || !pointerType && supportsTouchEvent || (this.mouseOverButton = null != e.target.closest("button,a"))
            }.bind(this)), _dom.default.addEventListener(player, window.PointerEvent ? "pointerenter" : "mouseenter", boundPointerEnter, {
                passive: !0,
                capture: !0
            }), this.boundPointerLeave),
            boundWindowKeyDown = (boundPointerLeave = boundPointerLeave || (this.boundPointerLeave = function(e) {
                this.mouseOverButton = null
            }.bind(this)), _dom.default.addEventListener(player, window.PointerEvent ? "pointerleave" : "mouseleave", boundPointerLeave, {
                passive: !0,
                capture: !0
            }), ! function(view) {
                var activeElement = document.activeElement;
                if (activeElement && !view.contains(activeElement)) try {
                    activeElement.blur()
                } catch (err) {
                    console.log("Error blurring element from previous view: " + err)
                }
            }(player), this.boundWindowKeyDown);
        boundWindowKeyDown = boundWindowKeyDown || (this.boundWindowKeyDown = function(e) {
            switch (_keyboard.default.normalizeKeyFromEvent(e)) {
                case "Enter":
                case " ":
                    return _focusmanager.default.hasExclusiveFocusScope() ? void 0 : void(this.currentVisibleMenu && !e.target.closest(".videoOsdPositionSlider") ? this.showOsd() : e.target.closest("BUTTON") || this.nowPlayingPositionSlider.dragging || (_playbackmanager.default.playPause(this.currentPlayer), shouldOsdBeShown(this) && setTimeout(this.boundShowOsdDefaultParams, 100), _browser.default.edge && (e.preventDefault(), e.stopPropagation())));
                case "b":
                case "B":
                    if (!_focusmanager.default.hasExclusiveFocusScope() && e.ctrlKey) return e.shiftKey ? (e.preventDefault(), void rewind(this)) : (e.preventDefault(), void _playbackmanager.default.previousChapter(this.currentPlayer));
                    break;
                case "f":
                case "F":
                    if (!_focusmanager.default.hasExclusiveFocusScope()) {
                        if (e.ctrlKey) return e.shiftKey ? (e.preventDefault(), void fastForward(this)) : (e.preventDefault(), void _playbackmanager.default.nextChapter(this.currentPlayer));
                        _playbackmanager.default.toggleFullscreen(this.currentPlayer)
                    }
                    break;
                case "m":
                case "M":
                    _focusmanager.default.hasExclusiveFocusScope() || _playbackmanager.default.toggleMute(this.currentPlayer)
            }
        }.bind(this)), _dom.default.addEventListener(window, "keydown", boundWindowKeyDown, {}), _mouse.default.requestMouseListening("videoosd")
    }, VideoOsd.prototype.onPause = function() {
        _baseview.default.prototype.onPause.apply(this, arguments);
        var statsOverlay = this.statsOverlay,
            statsOverlay = (statsOverlay && statsOverlay.enabled(!1), this.subtitleOffsetOverlay),
            statsOverlay = (statsOverlay && destroySubtitleOffsetOverlay(this), this.boundWindowKeyDown),
            statsOverlay = (statsOverlay && _dom.default.removeEventListener(window, "keydown", statsOverlay, {}), headerElement.classList.remove("videoOsdHeader", "videoosd-header-safe", "videoOsdHeader-hidden", "videoOsdHeader-locked", "hide", "videoOsd-customFont-x2", "videoOsd-customFont-remotecontrol"), backdropContainer.classList.remove("nowplaying-backdropcontainer-blur", "nowplaying-backdropcontainer-blur-high", "nowplaying-backdropcontainer-blur-extrasaturation", "nowplaying-backdropcontainer-blur-backdropfilter"), backgroundContainer.classList.remove("nowplaying-backgroundcontainer-blur", "nowplaying-backgroundcontainer-brighter", "nowplaying-backgroundcontainer-blur-backdropfilter"), clearBlurFromDocumentElement(), this.boundPointerMove),
            statsOverlay = (statsOverlay && _dom.default.removeEventListener(document, window.PointerEvent ? "pointermove" : "mousemove", statsOverlay, {
                passive: !0
            }), this.boundOnPlayerChange);
        statsOverlay && _events.default.off(_playbackmanager.default, "playerchange", statsOverlay), this.enableStopOnBack && (this.enableStopOnBack = !1, this.enableBackOnStop = !1, null != (statsOverlay = this.currentPlayer) && statsOverlay.isLocalPlayer && _usersettings.default.enableVideoUnderUI() ? _approuter.default.setTransparency("backdrop") : _playbackmanager.default.stop(statsOverlay)), this.releaseCurrentPlayer(), _mouse.default.releaseMouseListening("videoosd"), stopOsdHideTimer(this), _backdrop.default.clear(), this.setLockState(0), unlockOrientation(), setSystemUIHidden(!1)
    }, VideoOsd.prototype.destroy = function() {
        _baseview.default.prototype.destroy.apply(this, arguments);
        var videoOsdText = this.videoOsdText,
            videoOsdText = (videoOsdText && (_shortcuts.default.off(videoOsdText), this.videoOsdText = null), destroyPlayQueue(this), destroyLyricsRenderer(this), this.recordingButtonManager),
            bottomTabControllers = (videoOsdText && (videoOsdText.destroy(), this.recordingButtonManager = null), destroyStats(this), destroySubtitleOffsetOverlay(this), this.bottomTabControllers);
        if (bottomTabControllers) {
            for (let i = 0, length = bottomTabControllers.length; i < length; i++) bottomTabControllers[i] && bottomTabControllers[i].destroy();
            this.bottomTabControllers = null
        }
        this.boundPointerMove = null, this.boundWindowKeyDown = null, this.boundInputCommand = null, this.boundHideOsd = null, this.boundShowOsdDefaultParams = null, this.boundOnOsdHideTimeout = null, this.boundOnPlayerChange = null, this.upNextContainer = null, this.lastPlayerState = null
    }, _exports.default = VideoOsd
});