define(["exports","../utils/logger.js","../utils/utf8-conv.js","../utils/exception.js"],function(_exports,_logger,_utf8Conv,_exception){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.default=void 0;class AMF{static parseScriptData(arrayBuffer,dataOffset,dataSize){var data={};try{var name=AMF.parseValue(arrayBuffer,dataOffset,dataSize),value=AMF.parseValue(arrayBuffer,dataOffset+name.size,dataSize-name.size);data[name.data]=value.data}catch(e){_logger.default.e("AMF",e.toString())}return data}static parseObject(arrayBuffer,dataOffset,dataSize){if(dataSize<3)throw new _exception.IllegalStateException("Data not enough when parse ScriptDataObject");var name=AMF.parseString(arrayBuffer,dataOffset,dataSize),arrayBuffer=AMF.parseValue(arrayBuffer,dataOffset+name.size,dataSize-name.size),dataOffset=arrayBuffer.objectEnd;return{data:{name:name.data,value:arrayBuffer.data},size:name.size+arrayBuffer.size,objectEnd:dataOffset}}static parseVariable(arrayBuffer,dataOffset,dataSize){return AMF.parseObject(arrayBuffer,dataOffset,dataSize)}static parseString(arrayBuffer,dataOffset,dataSize){if(dataSize<2)throw new _exception.IllegalStateException("Data not enough when parse String");dataSize=new DataView(arrayBuffer,dataOffset,dataSize).getUint16(0,!1);let str;return{data:str=0<dataSize?(0,_utf8Conv.default)(new Uint8Array(arrayBuffer,dataOffset+2,dataSize)):"",size:2+dataSize}}static parseLongString(arrayBuffer,dataOffset,dataSize){if(dataSize<4)throw new _exception.IllegalStateException("Data not enough when parse LongString");dataSize=new DataView(arrayBuffer,dataOffset,dataSize).getUint32(0,!1);let str;return{data:str=0<dataSize?(0,_utf8Conv.default)(new Uint8Array(arrayBuffer,dataOffset+4,dataSize)):"",size:4+dataSize}}static parseDate(arrayBuffer,dataOffset,dataSize){if(dataSize<10)throw new _exception.IllegalStateException("Data size invalid when parse Date");arrayBuffer=new DataView(arrayBuffer,dataOffset,dataSize),dataOffset=arrayBuffer.getFloat64(0,!1);return dataOffset+=60*arrayBuffer.getInt16(8,!1)*1e3,{data:new Date(dataOffset),size:10}}static parseValue(arrayBuffer,dataOffset,dataSize){if(dataSize<1)throw new _exception.IllegalStateException("Data not enough when parse Value");var v=new DataView(arrayBuffer,dataOffset,dataSize);let offset=1;var type=v.getUint8(0);let value,objectEnd=!1;try{switch(type){case 0:value=v.getFloat64(1,!1),offset+=8;break;case 1:var b=v.getUint8(1);value=!!b,offset+=1;break;case 2:var amfstr=AMF.parseString(arrayBuffer,dataOffset+1,dataSize-1);value=amfstr.data,offset+=amfstr.size;break;case 3:{value={};let terminal=0;for(9==(16777215&v.getUint32(dataSize-4,!1))&&(terminal=3);offset<dataSize-4;){var amfobj=AMF.parseObject(arrayBuffer,dataOffset+offset,dataSize-offset-terminal);if(amfobj.objectEnd)break;value[amfobj.data.name]=amfobj.data.value,offset+=amfobj.size}offset<=dataSize-3&&9==(16777215&v.getUint32(offset-1,!1))&&(offset+=3);break}case 8:{value={},offset+=4;let terminal=0;for(9==(16777215&v.getUint32(dataSize-4,!1))&&(terminal=3);offset<dataSize-8;){var amfvar=AMF.parseVariable(arrayBuffer,dataOffset+offset,dataSize-offset-terminal);if(amfvar.objectEnd)break;value[amfvar.data.name]=amfvar.data.value,offset+=amfvar.size}if(offset<=dataSize-3){let marker=16777215&v.getUint32(offset-1,!1);9==marker&&(offset+=3)}break}case 9:value=void 0,offset=1,objectEnd=!0;break;case 10:value=[];var strictArrayLength=v.getUint32(1,!1);offset+=4;for(let i=0;i<strictArrayLength;i++){var val=AMF.parseValue(arrayBuffer,dataOffset+offset,dataSize-offset);value.push(val.data),offset+=val.size}break;case 11:var date=AMF.parseDate(arrayBuffer,dataOffset+1,dataSize-1);value=date.data,offset+=date.size;break;case 12:var amfLongStr=AMF.parseString(arrayBuffer,dataOffset+1,dataSize-1);value=amfLongStr.data,offset+=amfLongStr.size;break;default:offset=dataSize,_logger.default.w("AMF","Unsupported AMF value type "+type)}}catch(e){_logger.default.e("AMF",e.toString())}return{data:value,size:offset,objectEnd:objectEnd}}}var _default=AMF;_exports.default=_default});