define(["exports","../utils/logger.js","./speed-sampler.js","./loader.js","./fetch-stream-loader.js","./range-seek-handler.js","./param-seek-handler.js","../utils/exception.js"],function(_exports,_logger,_speedSampler,_loader,_fetchStreamLoader,_rangeSeekHandler,_paramSeekHandler,_exception){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.default=void 0;_exports.default=class{constructor(dataSource,config,extraData){this.TAG="IOController",this._config=config,this._extraData=extraData,this._stashInitialSize=393216,null!=config.stashInitialSize&&0<config.stashInitialSize&&(this._stashInitialSize=config.stashInitialSize),this._stashUsed=0,this._stashSize=this._stashInitialSize,this._bufferSize=3145728,this._stashBuffer=new ArrayBuffer(this._bufferSize),this._stashByteStart=0,!(this._enableStash=!0)===config.enableStashBuffer&&(this._enableStash=!1),this._loader=null,this._loaderClass=null,this._seekHandler=null,this._dataSource=dataSource,this._isWebSocketURL=/wss?:\/\/(.+?)/.test(dataSource.url),this._refTotalLength=dataSource.filesize||null,this._totalLength=this._refTotalLength,this._fullRequestFlag=!1,this._currentRange=null,this._redirectedURL=null,this._speedNormalized=0,this._speedSampler=new _speedSampler.default,this._speedNormalizeList=[64,128,256,384,512,768,1024,1536,2048,3072,4096],this._isEarlyEofReconnecting=!1,this._paused=!1,this._resumeFrom=0,this._onDataArrival=null,this._onSeeked=null,this._onError=null,this._onComplete=null,this._onRedirect=null,this._onRecoveredEarlyEof=null,this._selectSeekHandler(),this._selectLoader(),this._createLoader()}destroy(){this._loader.isWorking()&&this._loader.abort(),this._loader.destroy(),this._loader=null,this._loaderClass=null,this._dataSource=null,this._stashBuffer=null,this._stashUsed=this._stashSize=this._bufferSize=this._stashByteStart=0,this._currentRange=null,this._speedSampler=null,this._isEarlyEofReconnecting=!1,this._onDataArrival=null,this._onSeeked=null,this._onError=null,this._onComplete=null,this._onRedirect=null,this._onRecoveredEarlyEof=null,this._extraData=null}isWorking(){return this._loader&&this._loader.isWorking()&&!this._paused}isPaused(){return this._paused}get status(){return this._loader.status}get extraData(){return this._extraData}set extraData(data){this._extraData=data}get onDataArrival(){return this._onDataArrival}set onDataArrival(callback){this._onDataArrival=callback}get onSeeked(){return this._onSeeked}set onSeeked(callback){this._onSeeked=callback}get onError(){return this._onError}set onError(callback){this._onError=callback}get onComplete(){return this._onComplete}set onComplete(callback){this._onComplete=callback}get onRedirect(){return this._onRedirect}set onRedirect(callback){this._onRedirect=callback}get onRecoveredEarlyEof(){return this._onRecoveredEarlyEof}set onRecoveredEarlyEof(callback){this._onRecoveredEarlyEof=callback}get currentURL(){return this._dataSource.url}get hasRedirect(){return null!=this._redirectedURL||null!=this._dataSource.redirectedURL}get currentRedirectedURL(){return this._redirectedURL||this._dataSource.redirectedURL}get currentSpeed(){return this._speedSampler.lastSecondKBps}get loaderType(){return this._loader.type}_selectSeekHandler(){var config=this._config;if("range"===config.seekType)this._seekHandler=new _rangeSeekHandler.default(this._config.rangeLoadZeroStart);else if("param"===config.seekType){var paramStart=config.seekParamStart||"bstart",paramEnd=config.seekParamEnd||"bend";this._seekHandler=new _paramSeekHandler.default(paramStart,paramEnd)}else{if("custom"!==config.seekType)throw new _exception.InvalidArgumentException("Invalid seekType in config: ".concat(config.seekType));if("function"!=typeof config.customSeekHandler)throw new _exception.InvalidArgumentException("Custom seekType specified in config but invalid customSeekHandler!");this._seekHandler=new config.customSeekHandler}}_selectLoader(){if(null!=this._config.customLoader)this._loaderClass=this._config.customLoader;else{if(!_fetchStreamLoader.default.isSupported())throw new _exception.RuntimeException("Your browser doesn't support xhr with arraybuffer responseType!");this._loaderClass=_fetchStreamLoader.default}}_createLoader(){this._loader=new this._loaderClass(this._seekHandler,this._config),!1===this._loader.needStashBuffer&&(this._enableStash=!1),this._loader.onContentLengthKnown=this._onContentLengthKnown.bind(this),this._loader.onURLRedirect=this._onURLRedirect.bind(this),this._loader.onDataArrival=this._onLoaderChunkArrival.bind(this),this._loader.onComplete=this._onLoaderComplete.bind(this),this._loader.onError=this._onLoaderError.bind(this)}open(optionalFrom){this._currentRange={from:0,to:-1},optionalFrom&&(this._currentRange.from=optionalFrom),this._speedSampler.reset(),optionalFrom||(this._fullRequestFlag=!0),this._loader.open(this._dataSource,Object.assign({},this._currentRange))}abort(){this._loader.abort(),this._paused&&(this._paused=!1,this._resumeFrom=0)}pause(){this.isWorking()&&(this._loader.abort(),0!==this._stashUsed?(this._resumeFrom=this._stashByteStart,this._currentRange.to=this._stashByteStart-1):this._resumeFrom=this._currentRange.to+1,this._stashUsed=0,this._stashByteStart=0,this._paused=!0)}resume(){var bytes;this._paused&&(this._paused=!1,bytes=this._resumeFrom,this._resumeFrom=0,this._internalSeek(bytes,!0))}seek(bytes){this._paused=!1,this._stashUsed=0,this._stashByteStart=0,this._internalSeek(bytes,!0)}_internalSeek(bytes,dropUnconsumed){this._loader.isWorking()&&this._loader.abort(),this._flushStashBuffer(dropUnconsumed),this._loader.destroy(),this._loader=null;dropUnconsumed={from:bytes,to:-1};this._currentRange={from:dropUnconsumed.from,to:-1},this._speedSampler.reset(),this._stashSize=this._stashInitialSize,this._createLoader(),this._loader.open(this._dataSource,dropUnconsumed),this._onSeeked&&this._onSeeked()}updateUrl(url){if(!url||"string"!=typeof url||0===url.length)throw new _exception.InvalidArgumentException("Url must be a non-empty string!");this._dataSource.url=url}_expandBuffer(expectedBytes){let bufferNewSize=this._stashSize;for(;bufferNewSize+1048576<expectedBytes;)bufferNewSize*=2;var newBuffer,stashOldArray;(bufferNewSize+=1048576)!==this._bufferSize&&(newBuffer=new ArrayBuffer(bufferNewSize),0<this._stashUsed&&(stashOldArray=new Uint8Array(this._stashBuffer,0,this._stashUsed),new Uint8Array(newBuffer,0,bufferNewSize).set(stashOldArray,0)),this._stashBuffer=newBuffer,this._bufferSize=bufferNewSize)}_normalizeSpeed(input){var mid,list=this._speedNormalizeList,last=list.length-1;let lbound=0,ubound=last;if(input<list[0])return list[0];for(;lbound<=ubound;){if((mid=lbound+Math.floor((ubound-lbound)/2))===last||input>=list[mid]&&input<list[mid+1])return list[mid];list[mid]<input?lbound=mid+1:ubound=mid-1}}_adjustStashSize(normalized){let stashSizeKB=0;normalized=1024*(stashSizeKB=8192<(stashSizeKB=this._config.isLive||normalized<512?normalized:512<=normalized&&normalized<=1024?Math.floor(1.5*normalized):2*normalized)?8192:stashSizeKB)+1048576;this._bufferSize<normalized&&this._expandBuffer(normalized),this._stashSize=1024*stashSizeKB}_dispatchChunks(chunks,byteStart){return this._currentRange.to=byteStart+chunks.byteLength-1,this._onDataArrival(chunks,byteStart)}_onURLRedirect(redirectedURL){this._redirectedURL=redirectedURL,this._onRedirect&&this._onRedirect(redirectedURL)}_onContentLengthKnown(contentLength){contentLength&&this._fullRequestFlag&&(this._totalLength=contentLength,this._fullRequestFlag=!1)}_onLoaderChunkArrival(chunk,byteStart,receivedLength){if(!this._onDataArrival)throw new _exception.IllegalStateException("IOController: No existing consumer (onDataArrival) callback!");if(!this._paused){this._isEarlyEofReconnecting&&(this._isEarlyEofReconnecting=!1,this._onRecoveredEarlyEof)&&this._onRecoveredEarlyEof(),this._speedSampler.addBytes(chunk.byteLength);var KBps=this._speedSampler.lastSecondKBps;if(0!==KBps&&(KBps=this._normalizeSpeed(KBps),this._speedNormalized!==KBps)&&(this._speedNormalized=KBps,this._adjustStashSize(KBps)),this._enableStash)if(0===this._stashUsed&&0===this._stashByteStart&&(this._stashByteStart=byteStart),this._stashUsed+chunk.byteLength<=this._stashSize){let stashArray=new Uint8Array(this._stashBuffer,0,this._stashSize);stashArray.set(new Uint8Array(chunk),this._stashUsed),this._stashUsed+=chunk.byteLength}else{let stashArray=new Uint8Array(this._stashBuffer,0,this._bufferSize);if(0<this._stashUsed){KBps=this._stashBuffer.slice(0,this._stashUsed);let consumed=this._dispatchChunks(KBps,this._stashByteStart);if(consumed<KBps.byteLength){if(0<consumed){let remainArray=new Uint8Array(KBps,consumed);stashArray.set(remainArray,0),this._stashUsed=remainArray.byteLength,this._stashByteStart+=consumed}}else this._stashUsed=0,this._stashByteStart+=consumed;this._stashUsed+chunk.byteLength>this._bufferSize&&(this._expandBuffer(this._stashUsed+chunk.byteLength),stashArray=new Uint8Array(this._stashBuffer,0,this._bufferSize)),stashArray.set(new Uint8Array(chunk),this._stashUsed),this._stashUsed+=chunk.byteLength}else{let consumed=this._dispatchChunks(chunk,byteStart);if(consumed<chunk.byteLength){let remain=chunk.byteLength-consumed;remain>this._bufferSize&&(this._expandBuffer(remain),stashArray=new Uint8Array(this._stashBuffer,0,this._bufferSize)),stashArray.set(new Uint8Array(chunk,consumed),0),this._stashUsed+=remain,this._stashByteStart=byteStart+consumed}}}else if(0===this._stashUsed){var remain,KBps=this._dispatchChunks(chunk,byteStart);KBps<chunk.byteLength&&((remain=chunk.byteLength-KBps)>this._bufferSize&&this._expandBuffer(remain),new Uint8Array(this._stashBuffer,0,this._bufferSize).set(new Uint8Array(chunk,KBps),0),this._stashUsed+=remain,this._stashByteStart=byteStart+KBps)}else{this._stashUsed+chunk.byteLength>this._bufferSize&&this._expandBuffer(this._stashUsed+chunk.byteLength);let stashArray=new Uint8Array(this._stashBuffer,0,this._bufferSize),consumed=(stashArray.set(new Uint8Array(chunk),this._stashUsed),this._stashUsed+=chunk.byteLength,this._dispatchChunks(this._stashBuffer.slice(0,this._stashUsed),this._stashByteStart));consumed<this._stashUsed&&0<consumed&&(remain=new Uint8Array(this._stashBuffer,consumed),stashArray.set(remain,0)),this._stashUsed-=consumed,this._stashByteStart+=consumed}}}_flushStashBuffer(dropUnconsumed){if(0<this._stashUsed){var buffer=this._stashBuffer.slice(0,this._stashUsed),consumed=this._dispatchChunks(buffer,this._stashByteStart),remain=buffer.byteLength-consumed;if(consumed<buffer.byteLength){if(!dropUnconsumed)return 0<consumed&&(dropUnconsumed=new Uint8Array(this._stashBuffer,0,this._bufferSize),buffer=new Uint8Array(buffer,consumed),dropUnconsumed.set(buffer,0),this._stashUsed=buffer.byteLength,this._stashByteStart+=consumed),0;_logger.default.w(this.TAG,"".concat(remain," bytes unconsumed data remain when flush buffer, dropped"))}return this._stashUsed=0,this._stashByteStart=0,remain}return 0}_onLoaderComplete(from,to){this._flushStashBuffer(!0),this._onComplete&&this._onComplete(this._extraData)}_onLoaderError(type,data){switch(_logger.default.e(this.TAG,"Loader error, code = ".concat(data.code,", msg = ").concat(data.msg)),this._flushStashBuffer(!1),this._isEarlyEofReconnecting&&(this._isEarlyEofReconnecting=!1,type=_loader.LoaderErrors.UNRECOVERABLE_EARLY_EOF),type){case _loader.LoaderErrors.EARLY_EOF:var nextFrom;if(!this._config.isLive)if(this._totalLength)return void((nextFrom=this._currentRange.to+1)<this._totalLength&&(_logger.default.w(this.TAG,"Connection lost, trying reconnect..."),this._isEarlyEofReconnecting=!0,this._internalSeek(nextFrom,!1)));type=_loader.LoaderErrors.UNRECOVERABLE_EARLY_EOF;break;case _loader.LoaderErrors.UNRECOVERABLE_EARLY_EOF:case _loader.LoaderErrors.CONNECTING_TIMEOUT:case _loader.LoaderErrors.HTTP_STATUS_CODE_INVALID:case _loader.LoaderErrors.EXCEPTION:}if(!this._onError)throw new _exception.RuntimeException("IOException: "+data.msg);this._onError(type,data)}}});