define(["exports","../utils/logger.js","./mp4-generator.js","./aac-silent.js","../../browser.js","../core/media-segment-info.js","../utils/exception.js"],function(_exports,_logger,_mp4Generator,_aacSilent,_browser,_mediaSegmentInfo,_exception){function getChromeVersion(){var result=navigator.userAgent.match(/Chrome\/(\d+)/i);return result?parseInt(result[1]):0}Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.default=void 0;_exports.default=class{constructor(config){this.TAG="MP4Remuxer",this._config=config,this._isLive=!0===config.isLive,this._dtsBase=-1,this._dtsBaseInited=!1,this._audioDtsBase=1/0,this._videoDtsBase=1/0,this._audioNextDts=void 0,this._videoNextDts=void 0,this._audioStashedLastSample=null,this._videoStashedLastSample=null,this._audioMeta=null,this._videoMeta=null,this._audioSegmentInfoList=new _mediaSegmentInfo.MediaSegmentInfoList("audio"),this._videoSegmentInfoList=new _mediaSegmentInfo.MediaSegmentInfoList("video"),this._onInitSegment=null,this._onMediaSegment=null,this._forceFirstIDR=_browser.default.chrome&&getChromeVersion()<=50,this._fillSilentAfterSeek=_browser.default.edge,this._mp3UseMpegAudio=!_browser.default.firefox,this._fillAudioTimestampGap=this._config.fixAudioTimestampGap}destroy(){this._dtsBase=-1,this._dtsBaseInited=!1,this._audioMeta=null,this._videoMeta=null,this._audioSegmentInfoList.clear(),this._audioSegmentInfoList=null,this._videoSegmentInfoList.clear(),this._videoSegmentInfoList=null,this._onInitSegment=null,this._onMediaSegment=null}bindDataSource(producer){return producer.onDataAvailable=this.remux.bind(this),producer.onTrackMetadata=this._onTrackMetadataReceived.bind(this),this}get onInitSegment(){return this._onInitSegment}set onInitSegment(callback){this._onInitSegment=callback}get onMediaSegment(){return this._onMediaSegment}set onMediaSegment(callback){this._onMediaSegment=callback}insertDiscontinuity(){this._audioNextDts=this._videoNextDts=void 0}seek(originalDts){this._audioStashedLastSample=null,this._videoStashedLastSample=null,this._videoSegmentInfoList.clear(),this._audioSegmentInfoList.clear()}remux(audioTrack,videoTrack){if(!this._onMediaSegment)throw new _exception.IllegalStateException("MP4Remuxer: onMediaSegment callback must be specificed!");this._dtsBaseInited||this._calculateDtsBase(audioTrack,videoTrack),this._remuxVideo(videoTrack),this._remuxAudio(audioTrack)}_onTrackMetadataReceived(type,metadata){let metabox=null,container="mp4",codec=metadata.codec;if("audio"===type)this._audioMeta=metadata,metabox="mp3"===metadata.codec&&this._mp3UseMpegAudio?(container="mpeg",codec="",new Uint8Array):_mp4Generator.default.initSegment([metadata]);else{if("video"!==type)return;this._videoMeta=metadata,metabox=_mp4Generator.default.initSegment([metadata])}if(!this._onInitSegment)throw new _exception.IllegalStateException("MP4Remuxer: onInitSegment callback must be specified!");this._onInitSegment(type,{type:type,data:metabox.buffer,codec:codec,container:"".concat(type,"/").concat(container),mediaDuration:metadata.duration})}_calculateDtsBase(audioTrack,videoTrack){this._dtsBaseInited||(audioTrack.samples&&audioTrack.samples.length&&(this._audioDtsBase=audioTrack.samples[0].dts),videoTrack.samples&&videoTrack.samples.length&&(this._videoDtsBase=videoTrack.samples[0].dts),this._dtsBase=Math.min(this._audioDtsBase,this._videoDtsBase),this._dtsBaseInited=!0)}flushStashedSamples(){var videoSample=this._videoStashedLastSample,audioSample=this._audioStashedLastSample,videoTrack={type:"video",id:1,sequenceNumber:0,samples:[],length:0},videoSample=(null!=videoSample&&(videoTrack.samples.push(videoSample),videoTrack.length=videoSample.length),{type:"audio",id:2,sequenceNumber:0,samples:[],length:0});null!=audioSample&&(videoSample.samples.push(audioSample),videoSample.length=audioSample.length),this._videoStashedLastSample=null,this._audioStashedLastSample=null,this._remuxVideo(videoTrack,!0),this._remuxAudio(videoSample,!0)}_remuxAudio(audioTrack,force){if(null!=this._audioMeta){var samples=audioTrack.samples;let dtsCorrection,firstDts=-1,lastDts;var refSampleDuration=this._audioMeta.refSampleDuration,mpegRawTrack="mp3"===this._audioMeta.codec&&this._mp3UseMpegAudio,firstSegmentAfterSeek=this._dtsBaseInited&&void 0===this._audioNextDts;let insertPrefixSilentFrame=!1;if(samples&&0!==samples.length&&(1!==samples.length||force)){let offset=0,mdatbox=null,mdatBytes=0,lastSample=(mdatBytes=mpegRawTrack?(offset=0,audioTrack.length):(offset=8)+audioTrack.length,null);1<samples.length&&(lastSample=samples.pop(),mdatBytes-=lastSample.length),null!=this._audioStashedLastSample&&(force=this._audioStashedLastSample,this._audioStashedLastSample=null,samples.unshift(force),mdatBytes+=force.length),null!=lastSample&&(this._audioStashedLastSample=lastSample);var silentUnit,force=samples[0].dts-this._dtsBase;if(this._audioNextDts)dtsCorrection=force-this._audioNextDts;else if(this._audioSegmentInfoList.isEmpty())dtsCorrection=0,this._fillSilentAfterSeek&&!this._videoSegmentInfoList.isEmpty()&&"mp3"!==this._audioMeta.originalCodec&&(insertPrefixSilentFrame=!0);else{let lastSample=this._audioSegmentInfoList.getLastSampleBefore(force);if(null!=lastSample){let distance=force-(lastSample.originalDts+lastSample.duration);distance<=3&&(distance=0);var expectedDts=lastSample.dts+lastSample.duration+distance;dtsCorrection=force-expectedDts}else dtsCorrection=0}insertPrefixSilentFrame&&(expectedDts=force-dtsCorrection,null!=(force=this._videoSegmentInfoList.getLastSegmentBefore(force))&&force.beginDts<expectedDts?(silentUnit=_aacSilent.default.getSilentFrame(this._audioMeta.originalCodec,this._audioMeta.channelCount))&&(dts=force.beginDts,expectedDts=expectedDts-force.beginDts,_logger.default.v(this.TAG,"InsertPrefixSilentAudio: dts: ".concat(dts,", duration: ").concat(expectedDts)),samples.unshift({unit:silentUnit,dts:dts,pts:dts}),mdatBytes+=silentUnit.byteLength):insertPrefixSilentFrame=!1);var mp4Samples=[];for(let i=0;i<samples.length;i++){let sample=samples[i];var unit=sample.unit,originalDts=sample.dts-this._dtsBase;let dts=originalDts-dtsCorrection,sampleDuration=(-1===firstDts&&(firstDts=dts),0);if(i!==samples.length-1){var nextDts=samples[i+1].dts-this._dtsBase-dtsCorrection;sampleDuration=nextDts-dts}else if(null!=lastSample){let nextDts=lastSample.dts-this._dtsBase-dtsCorrection;sampleDuration=nextDts-dts}else sampleDuration=1<=mp4Samples.length?mp4Samples[mp4Samples.length-1].duration:Math.floor(refSampleDuration);let needFillSilentFrames=!1,silentFrames=null;if(sampleDuration>1.5*refSampleDuration&&"mp3"!==this._audioMeta.codec&&this._fillAudioTimestampGap&&!_browser.default.safari){needFillSilentFrames=!0;var nextDts=Math.abs(sampleDuration-refSampleDuration),frameCount=Math.ceil(nextDts/refSampleDuration);let currentDts=dts+refSampleDuration,silentUnit=(_logger.default.w(this.TAG,"Large audio timestamp gap detected, may cause AV sync to drift. Silent frames will be generated to avoid unsync.\n"+"dts: ".concat(dts+sampleDuration," ms, expected: ").concat(dts+Math.round(refSampleDuration)," ms, ")+"delta: ".concat(Math.round(nextDts)," ms, generate: ").concat(frameCount," frames")),_aacSilent.default.getSilentFrame(this._audioMeta.originalCodec,this._audioMeta.channelCount));null==silentUnit&&(_logger.default.w(this.TAG,"Unable to generate silent frame for "+"".concat(this._audioMeta.originalCodec," with ").concat(this._audioMeta.channelCount," channels, repeat last frame")),silentUnit=unit),silentFrames=[];for(let j=0;j<frameCount;j++){var intDts=Math.round(currentDts),previousFrame=(0<silentFrames.length&&((previousFrame=silentFrames[silentFrames.length-1]).duration=intDts-previousFrame.dts),{dts:intDts,pts:intDts,cts:0,unit:silentUnit,size:silentUnit.byteLength,duration:0,originalDts:originalDts,flags:{isLeading:0,dependsOn:1,isDependedOn:0,hasRedundancy:0}});silentFrames.push(previousFrame),mdatBytes+=previousFrame.size,currentDts+=refSampleDuration}unit=silentFrames[silentFrames.length-1];unit.duration=dts+sampleDuration-unit.dts,sampleDuration=Math.round(refSampleDuration)}mp4Samples.push({dts:dts,pts:dts,cts:0,unit:sample.unit,size:sample.unit.byteLength,duration:sampleDuration,originalDts:originalDts,flags:{isLeading:0,dependsOn:1,isDependedOn:0,hasRedundancy:0}}),needFillSilentFrames&&mp4Samples.push.apply(mp4Samples,silentFrames)}mpegRawTrack?mdatbox=new Uint8Array(mdatBytes):((mdatbox=new Uint8Array(mdatBytes))[0]=mdatBytes>>>24&255,mdatbox[1]=mdatBytes>>>16&255,mdatbox[2]=mdatBytes>>>8&255,mdatbox[3]=255&mdatBytes,mdatbox.set(_mp4Generator.default.types.mdat,4));for(let i=0;i<mp4Samples.length;i++){let unit=mp4Samples[i].unit;mdatbox.set(unit,offset),offset+=unit.byteLength}force=mp4Samples[mp4Samples.length-1],expectedDts=(lastDts=force.dts+force.duration,this._audioNextDts=lastDts,new _mediaSegmentInfo.MediaSegmentInfo);expectedDts.beginDts=firstDts,expectedDts.endDts=lastDts,expectedDts.beginPts=firstDts,expectedDts.endPts=lastDts,expectedDts.originalBeginDts=mp4Samples[0].originalDts,expectedDts.originalEndDts=force.originalDts+force.duration,expectedDts.firstSample=new _mediaSegmentInfo.SampleInfo(mp4Samples[0].dts,mp4Samples[0].pts,mp4Samples[0].duration,mp4Samples[0].originalDts,!1),expectedDts.lastSample=new _mediaSegmentInfo.SampleInfo(force.dts,force.pts,force.duration,force.originalDts,!1),this._isLive||this._audioSegmentInfoList.append(expectedDts),audioTrack.samples=mp4Samples,audioTrack.sequenceNumber++;let moofbox=null;moofbox=mpegRawTrack?new Uint8Array:_mp4Generator.default.moof(audioTrack.sequenceNumber,firstDts,audioTrack),audioTrack.samples=[],audioTrack.length=0;var dts={type:"audio",data:this._mergeBoxes(moofbox,mdatbox).buffer,sampleCount:mp4Samples.length,info:expectedDts};mpegRawTrack&&firstSegmentAfterSeek&&(dts.timestampOffset=firstDts),this._onMediaSegment("audio",dts)}}}_remuxVideo(videoTrack,force){if(null!=this._videoMeta){var track=videoTrack,samples=track.samples;let dtsCorrection,firstDts=-1,lastDts,firstPts=-1,lastPts;if(samples&&0!==samples.length&&(1!==samples.length||force)){let offset=8;var mdatbox=null;let mdatBytes=8+videoTrack.length,lastSample=null;1<samples.length&&(lastSample=samples.pop(),mdatBytes-=lastSample.length),null!=this._videoStashedLastSample&&(force=this._videoStashedLastSample,this._videoStashedLastSample=null,samples.unshift(force),mdatBytes+=force.length),null!=lastSample&&(this._videoStashedLastSample=lastSample);videoTrack=samples[0].dts-this._dtsBase;if(this._videoNextDts)dtsCorrection=videoTrack-this._videoNextDts;else if(this._videoSegmentInfoList.isEmpty())dtsCorrection=0;else{let lastSample=this._videoSegmentInfoList.getLastSampleBefore(videoTrack);if(null!=lastSample){let distance=videoTrack-(lastSample.originalDts+lastSample.duration);distance<=3&&(distance=0);force=lastSample.dts+lastSample.duration+distance;dtsCorrection=videoTrack-force}else dtsCorrection=0}var info=new _mediaSegmentInfo.MediaSegmentInfo,mp4Samples=[];for(let i=0;i<samples.length;i++){let sample=samples[i];var originalDts=sample.dts-this._dtsBase,isKeyframe=sample.isKeyframe,dts=originalDts-dtsCorrection,cts=sample.cts,pts=dts+cts;-1===firstDts&&(firstDts=dts,firstPts=pts);let sampleDuration=0;if(i!==samples.length-1){var nextDts=samples[i+1].dts-this._dtsBase-dtsCorrection;sampleDuration=nextDts-dts}else if(null!=lastSample){let nextDts=lastSample.dts-this._dtsBase-dtsCorrection;sampleDuration=nextDts-dts}else sampleDuration=1<=mp4Samples.length?mp4Samples[mp4Samples.length-1].duration:Math.floor(this._videoMeta.refSampleDuration);isKeyframe&&((nextDts=new _mediaSegmentInfo.SampleInfo(dts,pts,sampleDuration,sample.dts,!0)).fileposition=sample.fileposition,info.appendSyncPoint(nextDts)),mp4Samples.push({dts:dts,pts:pts,cts:cts,units:sample.units,size:sample.length,isKeyframe:isKeyframe,duration:sampleDuration,originalDts:originalDts,flags:{isLeading:0,dependsOn:isKeyframe?2:1,isDependedOn:isKeyframe?1:0,hasRedundancy:0,isNonSync:isKeyframe?0:1}})}(mdatbox=new Uint8Array(mdatBytes))[0]=mdatBytes>>>24&255,mdatbox[1]=mdatBytes>>>16&255,mdatbox[2]=mdatBytes>>>8&255,mdatbox[3]=255&mdatBytes,mdatbox.set(_mp4Generator.default.types.mdat,4);for(let i=0;i<mp4Samples.length;i++)for(var units=mp4Samples[i].units;units.length;){var data=units.shift().data;mdatbox.set(data,offset),offset+=data.byteLength}videoTrack=mp4Samples[mp4Samples.length-1],videoTrack=(lastDts=videoTrack.dts+videoTrack.duration,lastPts=videoTrack.pts+videoTrack.duration,this._videoNextDts=lastDts,info.beginDts=firstDts,info.endDts=lastDts,info.beginPts=firstPts,info.endPts=lastPts,info.originalBeginDts=mp4Samples[0].originalDts,info.originalEndDts=videoTrack.originalDts+videoTrack.duration,info.firstSample=new _mediaSegmentInfo.SampleInfo(mp4Samples[0].dts,mp4Samples[0].pts,mp4Samples[0].duration,mp4Samples[0].originalDts,mp4Samples[0].isKeyframe),info.lastSample=new _mediaSegmentInfo.SampleInfo(videoTrack.dts,videoTrack.pts,videoTrack.duration,videoTrack.originalDts,videoTrack.isKeyframe),this._isLive||this._videoSegmentInfoList.append(info),track.samples=mp4Samples,track.sequenceNumber++,this._forceFirstIDR&&((force=mp4Samples[0].flags).dependsOn=2,force.isNonSync=0),_mp4Generator.default.moof(track.sequenceNumber,firstDts,track));track.samples=[],track.length=0,this._onMediaSegment("video",{type:"video",data:this._mergeBoxes(videoTrack,mdatbox).buffer,sampleCount:mp4Samples.length,info:info})}}}_mergeBoxes(moof,mdat){var result=new Uint8Array(moof.byteLength+mdat.byteLength);return result.set(moof,0),result.set(mdat,moof.byteLength),result}}});